
/*********************************************************************************
 *                                                                               *
 * LaVache.cpp                                                                   *
 *                                                                               *
 * Copyright (C) 2000/2002 Fasouil                                               *
 *                                                                               *
 *                                                                               *
 * This program is free software; you can redistribute it and/or                 *
 * modify it under the terms of the GNU General Public License                   *
 * as published by the Free Software Foundation; either version 2                *
 * of the License, or (at your option) any later version.                        *
 *                                                                               *
 *                                                                               *          
 * This program is distributed in the hope that it will be useful,               *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
 * GNU General Public License for more details.                                  *
 *                                                                               *
 *                                                                               *
 * You should have received a copy of the GNU General Public License             *
 * along with this program; if not, write to the Free Software                   *
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.    *
 * Or, point your browser to http://www.gnu.org/copyleft/gpl.html                *
 *                                                                               *
 *                                                                               *
 * The author can be reached at fasouil@hotmail.com                              *
 *********************************************************************************/ 

#include <windows.h>
#include <stdio.h>
#include "resource.h"
#include "Structures.h"

#include "LaVache.h"

///////////////////////////////////////////////
#define SafeDelete(X) {if (X) delete [] (X); (X)=NULL;} // cricri

CLaVache::CLaVache()
{
	m_bInit=false;

	m_pbPossibleNormal=NULL;
	m_psCountKeyLineNormal=NULL;
	m_pnPositionLineNormal=NULL;
	m_ppsAdressKeyLineNormal=NULL;
	m_pcKeyLineNormal=NULL;
	m_pnTamponChargeCapture=NULL;
	m_psCountKeyLinePrevious=NULL;
	m_pbPossiblePrevious=NULL;
	m_pnPositionLinePrevious=NULL;
	m_ppsAdressKeyLinePrevious=NULL;
	m_pcKeyLinePrevious=NULL;
	m_psKeyMaskPurple=NULL;
	m_pnArrayMaskPurple=NULL;
	m_psInterliveSort=NULL;
	m_psInterPixelNormal=NULL;
	m_psInterPixelPrevious=NULL;
	m_pnValueDiffPixelLine=NULL;


	m_pnArrayMaskPurple=new unsigned __int64[128*256];
	if (!m_pnArrayMaskPurple)
		return;

	m_psKeyMaskPurple=new short[128*256];
	if (!m_psKeyMaskPurple)
		return;

	m_pnArrayMaskChromi=new unsigned __int64[128*256];
	if (!m_pnArrayMaskChromi)
		return;

	m_psKeyMaskChromi=new short[128*256];
	if (!m_psKeyMaskChromi)
		return;

	m_cKeyLine=new unsigned char[256];
	if(!m_cKeyLine)
      return;

	m_pnMemoDistance=new int[CURRENTY*CURRENTY];
	if(!m_pnMemoDistance)
      return;

	m_pcKeyAlreadyFound=new char[128*256+1];
	if(!m_pcKeyAlreadyFound)
      return;

	m_pbPossibleNormal=new bool[CURRENTY*CURRENTY];
	if(!m_pbPossibleNormal)
		return;

	m_pbPossiblePrevious=new bool[CURRENTY*CURRENTY];
	if(!m_pbPossiblePrevious)
      return;
}


CLaVache::~CLaVache()
{
	SafeDelete(m_pcKeyLinePrevious);
	SafeDelete(m_ppsAdressKeyLinePrevious);
	SafeDelete(m_pnPositionLinePrevious);
	SafeDelete(m_psCountKeyLinePrevious);
	SafeDelete(m_pbPossibleNormal);             // cricri
	SafeDelete(m_pbPossiblePrevious);
	SafeDelete(m_pnTamponChargeCapture);
	SafeDelete(m_pcKeyLineNormal);
	SafeDelete(m_pnPositionLineNormal);
	SafeDelete(m_ppsAdressKeyLineNormal);
	SafeDelete(m_psCountKeyLineNormal);
	SafeDelete(m_cKeyLine);
	SafeDelete(m_pnMemoDistance);
	SafeDelete(m_pcKeyAlreadyFound);
	SafeDelete(m_psInterliveSort);
	SafeDelete(m_psInterPixelNormal);
	SafeDelete(m_psInterPixelPrevious);
	SafeDelete(m_pnValueDiffPixelLine);
	SafeDelete(m_pnArrayMaskChromi);
	SafeDelete(m_psKeyMaskChromi);
	SafeDelete(m_pnArrayMaskPurple);
	SafeDelete(m_psKeyMaskPurple);
}

//debug
double CLaVache::GetInfo()
{
	return m_fHeightBlackDynam;
	return m_dInfo;
}


bool CLaVache::GetPhase()
{
	return (m_bPhase);
}


bool CLaVache::IsInit()
{
	return (m_bInit);
}

void CLaVache::Destroy()
{
	m_bInit=false;
	SafeDelete (m_psCountKeyLineNormal);
	SafeDelete (m_pnPositionLineNormal);
	SafeDelete (m_ppsAdressKeyLineNormal);
	SafeDelete (m_pcKeyLineNormal);
	SafeDelete (m_psCountKeyLinePrevious);
	SafeDelete (m_pnPositionLinePrevious);
	SafeDelete (m_ppsAdressKeyLinePrevious);
	SafeDelete (m_pcKeyLinePrevious);
	SafeDelete (m_psInterliveSort);
	SafeDelete (m_psInterPixelNormal);
	SafeDelete (m_psInterPixelPrevious);
	SafeDelete (m_pnValueDiffPixelLine);
}

bool CLaVache::Init()
{
	m_bInit=false;
	m_dInfo=0;
	m_nSizeBufferX=0;
	m_nSizeBufferY=0;
	m_bPhase=false;
	m_nMarkChromi=0;
	m_nKeyFound=0;
	m_bKeyFound=false;
	m_nLengthTestChromi=0;
	m_nPositionTestChromi=0;
	m_bInit=false;
	m_bUsedLoadImage=false;
	m_bIsOdd=false;
	m_nTypeTryPrevious=0;
	m_bKeyRepeatLock=false;
	m_bKeyRepeatRead=false;
	m_nPositionKeyRepeat=0;
	m_nTestDone=0;
	m_nPositionKeyRepeatFound=0;
	m_nBadKeySynchrone=0;
	m_nGoodKeySynchrone=0;
	m_nBadKeySynchroneOld=0;
	m_fScrambSignalDetect=0;
	m_nRateGoodProba=0;
	m_nTestNormalUser=0;
	m_nTestPreviousUser=0;
	m_nLengthTestPurple=0;
	m_nPositionTestPurple=0;
	m_nMarkPurple=0;

	m_nPurpleLevel=DEFAULTPURPLELEVEL;	// NiKral

	m_bFilterPurple=false;
	m_bFilterSECAM=true;				// NiKral
	m_bFilterSSE=false;					// NiKral
	m_bFilterAverage = false;
	m_nHeightBlackBorder=0;
	m_fHeightBlackDynam=0;


	m_nProbaNormalDynam=200;	//200
	m_nProbaNormalLimitSup=m_nProbaNormalDynam*COEFFILTERLIMIT;
	m_nProbaNormalLimitInf=0;

	m_nProbaPreviousDynam=400;	//400
	m_nProbaPreviousLimitSup=m_nProbaPreviousDynam*COEFFILTERLIMIT;
	m_nProbaPreviousLimitInf=0;


	ZeroMemory(m_pbPossibleNormal,sizeof(*m_pbPossibleNormal)*CURRENTY*CURRENTY);   // cricri
	ZeroMemory(m_pbPossiblePrevious,sizeof(*m_pbPossiblePrevious)*CURRENTY*CURRENTY);
	ZeroMemory(m_pnLineCurent288,sizeof(m_pnLineCurent288));
	ZeroMemory(m_pnLineNext32,sizeof(m_pnLineNext32));
	ZeroMemory(m_psSortLineCurrent,sizeof(m_psSortLineCurrent));
	ZeroMemory(m_pnLineOldSort288,sizeof(m_pnLineOldSort288));
	ZeroMemory(m_bOldKeyFound,sizeof(m_bOldKeyFound));
	ZeroMemory(m_pnColumnOldSortValue,sizeof(m_pnColumnOldSortValue));
	ZeroMemory(m_pnColumnOldSelect,sizeof(m_pnColumnOldSelect));
	ZeroMemory(m_pnColumnSelect,sizeof(m_pnColumnSelect));      // cricri
	ZeroMemory(m_psKeyRepeat,sizeof(m_psKeyRepeat));
	ZeroMemory(m_pnLineSort288,sizeof(m_pnLineSort288));

	if (!LoadFileKey())
		return m_bInit;

	if (!LoadFileChromi())
		return m_bInit;

	if (!LoadFilePurple())
		return m_bInit;

	if (!LoadFilePossibleNormal())
		return m_bInit;

	if (!LoadFileLineNormal())
		return m_bInit;

	if (!LoadFilePossiblePrevious())
		return m_bInit;
	
	if(!LoadFileLinePrevious())
		return m_bInit;

	m_psInterliveSort=new short[max(m_nTestNormalMaxi,m_nTestPreviousMaxi)];
	if (!m_psInterliveSort)
		return m_bInit;

	m_psInterPixelNormal=new short[max(m_nTestNormalMaxi,m_nTestPreviousMaxi)];
	if (!m_psInterPixelNormal)
		return m_bInit;

	m_psInterPixelPrevious=new short[max(m_nTestNormalMaxi,m_nTestPreviousMaxi)];
	if (!m_psInterPixelPrevious)
		return m_bInit;

	m_pnValueDiffPixelLine=new int[max(m_nTestNormalMaxi,m_nTestPreviousMaxi)];
	if (!m_pnValueDiffPixelLine)
		return m_bInit;

	m_bInit=true;
	return m_bInit;
}


void CLaVache::SetSizeBuffer(int nSizeBufferX,int nSizeBufferY)
{
	m_nSizeBufferX=nSizeBufferX;
	m_nSizeBufferY=nSizeBufferY;
}

inline bool CLaVache::UpdatePhase()
{
	const int nHeighStart=60;
	const int nHeighEnd=120;
	unsigned __int64 maskU =0x0000FF000000FF00LL; //Alain const removed for "m" asm with gcc3.3 
	unsigned __int64 maskV =0xFF000000FF000000LL;
	// NiKral const unsigned __int64 mask00=0x0000000000000000;

	int py;
	int NbU,NbV;
	int * pLine1;
	int * pLine2;
	int nPhase0=0;
	int nPhase1=0;
	
	__asm					 // __asm Block
	{
		// NiKral movq	mm2,mask00
		movq	mm6,maskU
		movq	mm7,maskV		
	}


	//calcul phase of trame
	for (py=nHeighStart;py<nHeighEnd-2;py+=2)
	{
		pLine1=m_pnLineCurent288[py];	//line
		pLine2=m_pnLineCurent288[py+1];	//line+1

		__asm                  // __asm Blockk
		{
		
			mov		edi,dword ptr[pLine1]
			mov		esi,dword ptr[pLine2]
			
			mov		ecx,2			//2 loop
			pxor	mm4,mm4
			pxor	mm5,mm5

			jmp		AutrePixUP
			align 16
		AutrePixUP:

			movq	mm0,byte ptr[edi]		//mm0=*pLine1
			movq	mm1,byte ptr[esi]		//mm1=*pLine2

			psubb	mm0,mm1					//mm0=mm0-mm1 (b)
			movq	mm1,mm0					//mm1=mm0

			pand	mm0,mm6					//mm0=mm0&maskU
			pand	mm1,mm7					//mm1=mm1&maskV

			paddb	mm4,mm0					//mm4+=mm0 (b)
			paddb	mm5,mm1					//mm5+=mm1 (b)

			movq	mm0,byte ptr[edi+8]		//mm0=*pLine1
			movq	mm1,byte ptr[esi+8]		//mm1=*pLine2

			psubb	mm0,mm1					//mm0=mm0-mm1 (b)
			movq	mm1,mm0					//mm1=mm0

			pand	mm0,mm6					//mm0=mm0&maskU
			pand	mm1,mm7					//mm1=mm1&maskV

			add		esi,16
			paddb	mm4,mm0					//mm4+=mm0 (b)
			
			add		edi,16
			paddb	mm5,mm1					//mm5+=mm1 (b)

			dec		ecx			
			jnz		AutrePixUP				//----

			movq	mm0,mm4					//mm0=mm4
			movq	mm1,mm5					//mm1=mm5

			psrlq	mm4,32					//mm4=mm4>>32
			psrlq	mm5,32					//mm5=mm5>>32
			
			paddd	mm0,mm4					//mm0+=mm4 (dw)
			paddd	mm1,mm5					//mm1+=mm5 (dw)

			movd	NbU,mm0
			movd	NbV,mm1
		}

		if (!NbU)
			nPhase0++;
		if (!NbV)
			nPhase1++;

	}

	if (nPhase0<nPhase1)
		m_bPhase=true;
	else
		m_bPhase=false;			

	_asm emms;				// output MMX mode

	return (true);
}



//UpdateMarkChromi for BT848
//use chrominance bug
inline bool CLaVache::UpdateMarkChromi()
{
	if (m_bKeyFound)
		return false;	//already found

	unsigned __int64 maskU =0x0000FF000000FF00LL;
	unsigned __int64 maskV =0xFF000000FF000000LL;
	unsigned __int64 mask00=0x0000000000000000LL;

	int py;
	int NbU,NbV;
	int * pLine1;
	int * pLine2;
	int * pLine3;
	int * pLine4;
	int nIncrement1=0;
	int nIncrement2=0;
	unsigned __int64 nMarkTest1=0;
	unsigned __int64 nMarkTest2=0;

	if (!m_bPhase)
		nIncrement1=1;
	else
		nIncrement2=1;

	__asm					 // __asm Blockk
	{
		movq	mm2,mask00
		movq	mm6,maskU
		movq	mm7,maskV		
	}

	//Calcul mark of chrominance 
	for (py=m_nPositionTestChromi;py<m_nPositionTestChromi+m_nLengthTestChromi;py+=2)
	{

		pLine1=m_pnLineCurent288[py+nIncrement1];
		pLine2=m_pnLineCurent288[py+nIncrement2];
		pLine3=m_pnLineCurent288[py+1+nIncrement1];
		pLine4=m_pnLineCurent288[py+1+nIncrement2];

		__asm                  // __asm Blockk
		{
			mov		edi,dword ptr[pLine1]
			pxor	mm4,mm4
			
			mov		esi,dword ptr[pLine3]
			mov		ecx,8

			jmp		AutrePixUMC
			align 16
		AutrePixUMC:

			//U

			movq	mm1,byte ptr[esi]		//mm1=*pLine3
			movq	mm0,byte ptr[edi]		//mm0=*pLine1

			psubb	mm0,mm1					//mm0=mm0-mm1 (b)
			pand	mm0,mm6					//mm0=mm0&maskU


			pcmpeqb	mm0,mm2					//mm0>?mask00 (b)
			paddb	mm4,mm0					//mm4+=mm0 (b)

			movq	mm1,byte ptr[esi+8]		//mm1=*pLine3
			movq	mm0,byte ptr[edi+8]		//mm0=*pLine1

			psubb	mm0,mm1					//mm0=mm0-mm1 (b)
			pand	mm0,mm6					//mm0=mm0&maskU

			add		esi,16	
			pcmpeqb	mm0,mm2					//mm0>?mask00 (b)
			
			add		edi,16						
			paddb	mm4,mm0					//mm4+=mm0 (b)

			dec		ecx			
			jnz		AutrePixUMC				//----


			mov		edi,dword ptr[pLine2]
			pxor	mm5,mm5			

			mov		esi,dword ptr[pLine4]
			mov		ecx,8

			jmp		AutrePixUMC2
			align 16
		AutrePixUMC2:

			//V

			movq	mm1,byte ptr[esi]		//mm1=*pLine4
			movq	mm0,byte ptr[edi]		//mm0=*pLine2

			psubb	mm0,mm1					//mm0=mm0-mm1 (b)
			pand	mm0,mm7					//mm0=mm0&maskV

			pcmpeqb	mm0,mm2					//mm0>?mask00 (b)
			paddb	mm5,mm0					//mm5+=mm0 (b)

			movq	mm1,byte ptr[esi+8]		//mm1=*pLine4
			movq	mm0,byte ptr[edi+8]		//mm0=*pLine2

			psubb	mm0,mm1					//mm0=mm0-mm1 (b)
			pand	mm0,mm7					//mm0=mm0&maskV
			
			add		esi,16	
			pcmpeqb	mm0,mm2					//mm0>?mask00 (b)
			
			add		edi,16						
			paddb	mm5,mm0					//mm5+=mm0 (b)

			dec		ecx			
			jnz		AutrePixUMC2			//----
			
			//addition
			movq	mm0,mm4					//mm0=mm4
			movq	mm1,mm5					//mm1=mm5

			psrlq	mm4,32					//mm4=mm4>>32
			psrlq	mm5,32					//mm5=mm5>>32
			
			paddb	mm0,mm4					//mm0+=mm4 (b)
			paddb	mm1,mm5					//mm1+=mm5 (b)
			
			movd	NbU,mm0
			movd	NbV,mm1

		}


		NbU=(((NbU&0x0000FF00)>>8)+0x20)&0xff;
		NbV=(((NbV&0xFF000000)>>24)+0x20)&0xff;


		nMarkTest1=nMarkTest1<<2;
		if (NbU>10)
			nMarkTest1|=1;

		nMarkTest2=nMarkTest2<<2;
		if (NbV>10)
			nMarkTest2|=1;
	}
	
	_asm emms;				// output off MMX mode

	//make the true mark
	nMarkTest1=(nMarkTest2<<nIncrement1|nMarkTest1<<nIncrement2)&0x7fffffffffffffffLL;

	if (nMarkTest1==0)
	{
		m_fScrambSignalDetect=(float)((m_fScrambSignalDetect*2.0+0.0)/3.0);
		return false;
	}

	m_fScrambSignalDetect=(float)((m_fScrambSignalDetect*2.0+1.0)/3.0);

	m_nMarkChromi=nMarkTest1;

	return true;
}


//UpdateMarkPurple for BT878
//use purple line
inline bool CLaVache::UpdateMarkPurple()
{
	if (m_bKeyFound)
		return false;	//already found

	int nPosition;
	unsigned __int64 nMarkTest1=0;
	unsigned __int64 nMarkTest2=0;
	int nTestLinePurple;
	int nPurple=0;

	//Calcul mask blue/red
	for (nPosition=0;nPosition<m_nLengthTestPurple;nPosition++)
	{
		nMarkTest1=nMarkTest1<<1;
		nTestLinePurple=DetectLineBlue(m_pnLineCurent288[nPosition+m_nPositionTestPurple]);
		if (nTestLinePurple)
			nPurple++;
		nMarkTest1|=nTestLinePurple;

		nMarkTest2=nMarkTest2<<1;
		nTestLinePurple=DetectLineRed(m_pnLineCurent288[nPosition+m_nPositionTestPurple]);
		if (nTestLinePurple)
			nPurple++;
		nMarkTest2|=nTestLinePurple;

	}

	if (nPurple<20)
		return false;	//not enouth purple lines


	if (!m_bPhase)
	{
		nMarkTest1=nMarkTest1&0x5555555555555555LL;
		nMarkTest2=nMarkTest2&0xAAAAAAAAAAAAAAAALL;
	}
	else
	{
		nMarkTest1=nMarkTest1&0xAAAAAAAAAAAAAAAALL;
		nMarkTest2=nMarkTest2&0x5555555555555555LL;
	}


	m_nMarkPurple=nMarkTest1|nMarkTest2;

	return true;
}


bool CLaVache::FindKeyWithMarkChromi()
{
	//if (m_bKeyFound)
	//	return false;	//already found

	//look for m_pnArrayMaskChromi[] with m_nMarkChromi
	int nBoundLow=0;
	int nBoundHigh=128*256-1;
	int nBoundMiddle=(nBoundHigh+nBoundLow)/2;

	if ((m_nMarkChromi>m_pnArrayMaskChromi[nBoundLow])
		||(m_nMarkChromi<m_pnArrayMaskChromi[nBoundHigh]))
		return false;

	while(nBoundLow+1<nBoundHigh)
	{
		if (m_pnArrayMaskChromi[nBoundMiddle]==m_nMarkChromi)
			break;

		if (m_pnArrayMaskChromi[nBoundMiddle]<m_nMarkChromi)
			nBoundHigh=nBoundMiddle;
		else
			nBoundLow=nBoundMiddle;

		nBoundMiddle=(nBoundHigh+nBoundLow)/2;
	}


	//set m_nKeyFound with m_psKeyMaskChromi
	if (m_pnArrayMaskChromi[nBoundMiddle]==m_nMarkChromi)
	{	//it's found -> magik !
		m_nKeyFound=m_psKeyMaskChromi[nBoundMiddle];
		m_bKeyFound=true;

		CreateLineOrder(m_nKeyFound,m_psSortLineCurrent);

		return true;
	}

	return false;
}



bool CLaVache::FindKeyWithMarkPurple()
{
	//if (m_bKeyFound)
	//	return false;	//already found

	//look for m_pnArrayMaskPurple[] with m_nMarkPurple
	int nBoundLow=0;
	int nBoundHigh=128*256-1;
	int nBoundMiddle=(nBoundHigh+nBoundLow)/2;

	if ((m_nMarkPurple>m_pnArrayMaskPurple[nBoundLow])
		||(m_nMarkPurple<m_pnArrayMaskPurple[nBoundHigh]))
		return false;

	while(nBoundLow+1<nBoundHigh)
	{
		if (m_pnArrayMaskPurple[nBoundMiddle]==m_nMarkPurple)
			break;

		if (m_pnArrayMaskPurple[nBoundMiddle]<m_nMarkPurple)
			nBoundHigh=nBoundMiddle;
		else
			nBoundLow=nBoundMiddle;

		nBoundMiddle=(nBoundHigh+nBoundLow)/2;

	}

	//set m_nKeyFound with m_psKeyMaskPurple
	if (m_pnArrayMaskPurple[nBoundMiddle]==m_nMarkPurple)
	{	//it's found -> magik !
		m_nKeyFound=m_psKeyMaskPurple[nBoundMiddle];
		m_bKeyFound=true;

		CreateLineOrder(m_nKeyFound,m_psSortLineCurrent);

		return true;
	}


	return false;
}


bool CLaVache::LoadFileChromi()
{
	FILE *sFile = fopen(File_ChromiKey, "rb");

	if(sFile == NULL)
      return false;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	// m_nLengthTestChromi
	fread(&m_nLengthTestChromi, sizeof(m_nLengthTestChromi),1,sFile);   

	// m_nPositionTestChromi
	fread(&m_nPositionTestChromi, sizeof(m_nPositionTestChromi),1,sFile);   
   
	for (int nKeyTested=0;nKeyTested<128*256;nKeyTested++)
	{
	   // m_pnArrayMaskChromi
	   fread(m_pnArrayMaskChromi+nKeyTested, sizeof(*m_pnArrayMaskChromi),1,sFile);

	   // m_psKeyMaskChromi
	   fread(m_psKeyMaskChromi+nKeyTested, sizeof(*m_psKeyMaskChromi),1,sFile);
	}


	fclose(sFile);

	if (m_nLengthTestChromi!=64)
		return false;

	if ((m_nPositionTestChromi+m_nLengthTestChromi>CURRENTY)
		||(m_nPositionTestChromi<0))
		return false;

	return true;
}


bool CLaVache::LoadFilePurple()
{
	FILE *sFile = fopen(File_PurpleKey, "rb");

	if(sFile == NULL)
      return false;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	// m_nLengthTestPurple
	fread(&m_nLengthTestPurple, sizeof(m_nLengthTestPurple),1,sFile);   

	// m_nPositionTestPurple
	fread(&m_nPositionTestPurple, sizeof(m_nPositionTestPurple),1,sFile);   
   
	for (int cleftest=0;cleftest<128*256;cleftest++)
	{
	   // m_pnArrayMaskPurple
	   fread(m_pnArrayMaskPurple+cleftest, sizeof(*m_pnArrayMaskPurple),1,sFile);

	   // ClefEmpreinteViolet
	   fread(m_psKeyMaskPurple+cleftest, sizeof(*m_psKeyMaskPurple),1,sFile);
	}

	fclose(sFile);

	if (m_nLengthTestPurple!=64)
		return false;

	if ((m_nPositionTestPurple+m_nLengthTestPurple>CURRENTY)
		||(m_nPositionTestPurple<0))
		return false;

	return true;
}


//debug
__int64 CLaVache::GetRDTSCTime() 
{
    union 
	{
	  __int64 ll;
	  struct { int lo;int hi ;} s;
	} time;

	__asm
	{
		cpuid
		rdtsc
		mov time.s.lo, eax
		mov time.s.hi, edx
	}

	return time.ll;
}


bool CLaVache::UpdateInputLine( short ** ppsInputBuffer, BOOL bIsOdd)
{
	int py;

	m_bIsOdd=bIsOdd;
	m_bKeyFound=false;

	//get actual line
	short ** ppsInBuf=ppsInputBuffer;
	if ((m_bUsedLoadImage)&&(m_pnTamponChargeCapture))
	{
		short * psLine[CURRENTY];
		for (py=0;py<CURRENTY;py++)
			psLine[py]=(short*)m_pnTamponChargeCapture+(py*2+(1-bIsOdd))*m_nSizeBufferX;
		ppsInBuf=psLine;
	}

	// NiKral
	for (py=0;py<OFFSET32;py+=4)
	{
		// First 32
		m_pnLineCurent288[py]=m_pnLineNext32[py];
		m_pnLineCurent288[py+1]=m_pnLineNext32[py+1];
		m_pnLineCurent288[py+2]=m_pnLineNext32[py+2];
		m_pnLineCurent288[py+3]=m_pnLineNext32[py+3];

		//copy next line buffer
		m_pnLineNext32[py]=(int*)ppsInBuf[CURRENTY-OFFSET32+py-1];
		m_pnLineNext32[py+1]=(int*)ppsInBuf[CURRENTY-OFFSET32+py];
		m_pnLineNext32[py+2]=(int*)ppsInBuf[CURRENTY-OFFSET32+py+1];
		m_pnLineNext32[py+3]=(int*)ppsInBuf[CURRENTY-OFFSET32+py+2];
	}

	//second 32->287
	for (py=0;py<CURRENTY-OFFSET32;py++)
		m_pnLineCurent288[py+OFFSET32]=(int*)ppsInBuf[py];

	if (!m_pnLineCurent288[0])
		return false;
	
	return true;
}


void CLaVache::UpdateOutputLine(short ** ppsOutputBuffer)
{
	for (int py=0;py<CURRENTY;py++)
	{	m_pnLineSort288[py]=m_pnLineCurent288[m_psSortLineCurrent[py]];
		ppsOutputBuffer[py]=(short*)m_pnLineSort288[py];
	}
}


void CLaVache::UpdateOldLine()
{

	m_bOldKeyFound[m_bIsOdd]=m_bKeyFound;

	for (int py=0;py<CURRENTY;py++)
		m_pnLineOldSort288[m_bIsOdd][py]=m_pnLineSort288[py];

	for (int i=0;i<NCOLUMNTESTED;i++)
		m_pnColumnOldSelect[m_bIsOdd][i]=m_pnColumnSelect[i];
}


bool CLaVache::LoadFileKey()
{
   
   int   nZlr;
   int   nInputValue;
#ifndef MM_LINUX
   FILE *sFile = fopen("Plugins/key.txt", "r");
#else
   char key_file[255];

   sprintf(key_file, "%s/%s", home_dir, "key.txt");
   FILE *sFile = fopen(key_file, "r");
#endif

   if(sFile == NULL)
      return false;

   for(nZlr=0; nZlr<256; nZlr++)
   {
      if(fscanf(sFile, "%d\n", &nInputValue) == EOF)
         return false;

      m_cKeyLine[nZlr] = (char)(nInputValue&0x1f);
   }

   fclose(sFile);
   return true;
}


inline void CLaVache::CreateLineOrder(int nKey, short * psSort)
{

	int i;
	BYTE j;
	short buffer[32];
	int offset;
	int increment;

	if ((nKey<0)||(nKey>=128*256))
		nKey=0;

	offset=(nKey>>7);
	increment=((nKey&0x7f)*2+1);

	FillMemory(buffer,sizeof(buffer),0xff);	//-1

	j = (BYTE)offset;

	for (i=0;i<255;i++)
	{
		if (buffer[m_cKeyLine[j]] == -1)
			psSort[i]=m_cKeyLine[j];
		else
			psSort[i]=buffer[m_cKeyLine[j]];

		buffer [m_cKeyLine[j]] = (short)(32+i);
		j += increment; 				// Note that j is a BYTE
	}


	CopyMemory(psSort+255,buffer,sizeof(buffer));
	psSort[287]=287;

}


bool CLaVache::FindKey(short ** ppsInputBuffer,short ** ppsOutputBuffer, \
					   BOOL bIsBT878,BOOL bIsOdd,bool bPhaseFrame)
{
	if (!UpdateInputLine(ppsInputBuffer,(bIsOdd!=0)))
		return m_bKeyFound;

	//1
	UseKeyRepeat();

	//2
	UpdatePhase();

	if (bIsBT878!=FALSE)
	{	//BT878
		if(UpdateMarkPurple()&&(!m_bKeyFound))
			FindKeyWithMarkPurple();
	}
	else
	{	//BT848
		if (UpdateMarkChromi()&&(!m_bKeyFound))
			FindKeyWithMarkChromi();
	}

	//3
	FindKeyWithDiff();
	
	RecordKeyRepeat(m_bKeyFound,m_nKeyFound);

	UpdateOutputLine(ppsOutputBuffer);

	//filter
	if (m_bKeyFound)
		FilterFrame(bPhaseFrame);

	UpdateOldLine();

	return (m_bKeyFound);
}


bool CLaVache::LoadFilePossibleNormal()
{

	FILE *sFile = fopen(File_PossibleNormal, "rb");

	if(sFile == NULL)
		return false;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	fread(m_pbPossibleNormal, sizeof(*m_pbPossibleNormal),CURRENTY*CURRENTY,sFile);

	fclose(sFile);

	return true;
}


bool CLaVache::LoadFileLineNormal()
{
   
	int   nZlr;
	FILE *sFile = fopen(File_LineNormal, "rb");
	int nLineIndex;
	int nFullSize;
	short * adresse_clef;

	if(sFile == NULL)
		return false;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	//number of lines
	fread(&m_nTestNormalMaxi, sizeof(m_nTestNormalMaxi),1,sFile);

	//total size
	fread(&nFullSize, sizeof(nFullSize),1,sFile);

	m_psCountKeyLineNormal=new short[nFullSize];
	if(m_psCountKeyLineNormal == NULL)
	{
		OutputDebugString("IDS_ERR_MEMORY");
		return false;
	}

	m_pnPositionLineNormal=new int[m_nTestNormalMaxi];
	if(m_pnPositionLineNormal == NULL)
	{
		OutputDebugString("IDS_ERR_MEMORY");
		return false;
	}

	m_ppsAdressKeyLineNormal=new short* [m_nTestNormalMaxi*CURRENTY*CURRENTY+1];
	if(m_ppsAdressKeyLineNormal == NULL)
	{
		OutputDebugString("IDS_ERR_MEMORY");
		return false;
	}


	m_pcKeyLineNormal=new unsigned char[m_nTestNormalMaxi*CURRENTY*CURRENTY];
	if(m_pcKeyLineNormal == NULL)
	{
		OutputDebugString("IDS_ERR_MEMORY");
		return false;
	}

	//load key values (dynamic array)
	fread(m_psCountKeyLineNormal, sizeof(*m_psCountKeyLineNormal),nFullSize,sFile);

	adresse_clef=m_psCountKeyLineNormal;
	for (nLineIndex=0;nLineIndex<m_nTestNormalMaxi;nLineIndex++)
	{
		// record the number of line
		fread(m_pnPositionLineNormal+nLineIndex, sizeof(*m_pnPositionLineNormal),1,sFile);

		//record numbe of key, line per line
		fread(m_pcKeyLineNormal+nLineIndex*CURRENTY*CURRENTY, sizeof(*m_pcKeyLineNormal),CURRENTY*CURRENTY,sFile);

		for(nZlr=0; nZlr<CURRENTY*CURRENTY; nZlr++)
		{
			//calcul pointer
			m_ppsAdressKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nZlr]=adresse_clef;
			adresse_clef+=*(m_pcKeyLineNormal+nLineIndex*CURRENTY*CURRENTY+nZlr);
		}

	}

	fclose(sFile);
	return true;
}

bool CLaVache::FindKeyNormal(int nLineIndex)
{
	int i;
	int nTopNearLineNear;
	int nBottomNearLineNear;
	int nPropaGoodKey;
	int nCurrentColumnTest;
	int nKeyTested,nIndexKeyTested;
	int nBestScore;
	int nKeyKeep=0;
	int nIndexTested=0;
	int nFlipLine;

	int nOldBadKey=m_nKeyFound;

	m_nTypeTryPrevious=0;

	//FindLineNormal
	if (!FindLineNormal(m_pnPositionLineNormal[nLineIndex],&nBottomNearLineNear,&nTopNearLineNear))
		return(false);		//no lines found
	
	if ((m_pcKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nBottomNearLineNear*CURRENTY+nTopNearLineNear]==0)
		&&(m_pcKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nTopNearLineNear*CURRENTY+nBottomNearLineNear]==0))
		return(false);		//no lines found

	// calcul m_pnDiffColumnNormal ?
	if (m_pnDiffColumnNormal[0]==-1)
	{	//m_pnDiffColumnNormal haven't yet calculed
		for (int py=0;py<CURRENTY;py++)	
			m_psSortLineCurrent[py]=py;

		//calcul nPropaGoodKey
		nPropaGoodKey=0;
		for (i=0;i<NCOLUMNTESTED;i++)
		{
			nPropaGoodKey+=CalculDiffColumn(i);
			m_pnDiffColumnNormal[i]=nPropaGoodKey;
		}

	}

	//choose nCurrentColumnTest with m_nTestDone
	nCurrentColumnTest=m_nTestDone/2+3;
	if (nCurrentColumnTest>NCOLUMNTESTED)
		nCurrentColumnTest=NCOLUMNTESTED;

	// CalculDiffColumn
	nBestScore=0x0FFFFFFF;
	for (nIndexKeyTested=0;nIndexKeyTested<m_pcKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nBottomNearLineNear*CURRENTY+nTopNearLineNear];nIndexKeyTested++)
	{
		nKeyTested=*(m_ppsAdressKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nBottomNearLineNear*CURRENTY+nTopNearLineNear]+nIndexKeyTested);
		CreateLineOrder(nKeyTested,m_psSortLineCurrent);

		nPropaGoodKey=0;
		for (i=0;i<nCurrentColumnTest;i++)	
		{
			nPropaGoodKey+=CalculDiffColumn(i);

			if (nPropaGoodKey>nBestScore)
				break;		// nPropaGoodKey is over nBestScore

		}
		
		nIndexTested++;

		if (nPropaGoodKey<nBestScore)
		{
			nBestScore=nPropaGoodKey;
			nKeyKeep=nKeyTested;
		}

	}

	//validation ?
	if (nIndexTested>0)
	{
		m_nRateGoodProba=(m_pnDiffColumnNormal[nCurrentColumnTest-1]-nBestScore)*100/(nBestScore+1);
		if (m_nRateGoodProba<0)
			m_nRateGoodProba=0;
		
		m_nKeyFound=(short)nKeyKeep;

		if (m_nRateGoodProba>(m_nProbaNormalDynam+80-m_pcKeyAlreadyFound[nKeyKeep]*35))	
		{

			CreateLineOrder(nKeyKeep,m_psSortLineCurrent);
			m_bKeyFound=true;
			m_nTestDone++;

			_asm emms;				// output MMX mode (used in CalculDiffColumn)

			//limit
			m_nProbaNormalLimitSup=(m_nProbaNormalLimitSup*COEFFILTERLIMIT+m_nRateGoodProba*COEFFILTERLIMIT)/(COEFFILTERLIMIT+1);
			if (m_nProbaNormalLimitSup>TresholdNormalLimitSup)
				m_nProbaNormalLimitSup=TresholdNormalLimitSup;

			return(true);
		}

	}


	
	//flip nBottomNearLineNear & nTopNearLineNear
	nFlipLine=nBottomNearLineNear;
	nBottomNearLineNear=nTopNearLineNear;
	nTopNearLineNear=nFlipLine;

	// CalculDiffColumn
	for (nIndexKeyTested=0;nIndexKeyTested<m_pcKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nBottomNearLineNear*CURRENTY+nTopNearLineNear];nIndexKeyTested++)
	{
		nKeyTested=*(m_ppsAdressKeyLineNormal[nLineIndex*CURRENTY*CURRENTY+nBottomNearLineNear*CURRENTY+nTopNearLineNear]+nIndexKeyTested);
		CreateLineOrder(nKeyTested,m_psSortLineCurrent);

		nPropaGoodKey=0;
		for (i=0;i<nCurrentColumnTest;i++)	
		{
			nPropaGoodKey+=CalculDiffColumn(i);

			if (nPropaGoodKey>nBestScore)
				break;			// nPropaGoodKey is over nBestScore
		}


		nIndexTested++;


		if (nPropaGoodKey<nBestScore)
		{
			nBestScore=nPropaGoodKey;
			nKeyKeep=nKeyTested;
		}


	}
	
	_asm emms;				// output MMX mode (used in CalculDiffColumn)


	//validation ?
	if (nIndexTested>0)
	{
		m_nRateGoodProba=(m_pnDiffColumnNormal[nCurrentColumnTest-1]-nBestScore)*100/(nBestScore+1);
		if (m_nRateGoodProba<0)
			m_nRateGoodProba=0;

		m_nKeyFound=(short)nKeyKeep;

		if (m_nRateGoodProba>m_nProbaNormalDynam+20-m_pcKeyAlreadyFound[nKeyKeep]*40)		//film
		{
			CreateLineOrder(nKeyKeep,m_psSortLineCurrent);

			m_bKeyFound=true;
			m_nTestDone++;

			//limit
			m_nProbaNormalLimitSup=(m_nProbaNormalLimitSup*COEFFILTERLIMIT+m_nRateGoodProba*COEFFILTERLIMIT)/(COEFFILTERLIMIT+1);
			if (m_nProbaNormalLimitSup>TresholdNormalLimitSup)
				m_nProbaNormalLimitSup=TresholdNormalLimitSup;

			return(true);
		}

	}

	//limit
	if ((m_nTestDone>0)&&(nOldBadKey!=m_nKeyFound)&&(m_pcKeyAlreadyFound[nKeyKeep]==0))
	{
		m_nProbaNormalLimitInf=(m_nProbaNormalLimitInf*COEFFILTERLIMIT+m_nRateGoodProba*COEFFILTERLIMIT)/(COEFFILTERLIMIT+1);
		if (m_nProbaNormalLimitInf>TresholdNormalLimitInf)
			m_nProbaNormalLimitInf=TresholdNormalLimitInf;
	}

	//incrise m_pcKeyAlreadyFound[nKeyKeep]
	m_pcKeyAlreadyFound[nKeyKeep]++;
	m_nTestDone++;

	return(false); 
}

inline bool CLaVache::FindLineNormal(int nLine,int * nBottomNearLineNear,int * nTopNearLineNear)
{ //trouve les lignes les plus ressemblantes dans l'image courante crypte (ligne du dessus et du dessous)
	int py;
	int nBestScore,nBestLine_dessus,nBestLine_dessous;

	nBestLine_dessus=0;
	nBestLine_dessous=0;
	nBestScore=0x0FFFFFFF;
	
	for (py=0;py<CURRENTY;py+=1)   
	{

		if (m_pbPossibleNormal[nLine+py*CURRENTY])
		{
			if (m_pnMemoDistance[py*CURRENTY+nLine]==-1)
			{
				CalculDiffLine(nLine,py);	//calcul distance
			}

				//find the min
			if ((m_pnMemoDistance[py*CURRENTY+nLine]!=-1)&&(m_pnMemoDistance[py*CURRENTY+nLine]<nBestScore))
			{
				nBestScore=m_pnMemoDistance[py*CURRENTY+nLine];
				nBestLine_dessus=py;

			}
		
		}
		
	}


	if (nBestScore==0x0FFFFFFF)
		return false;


	nBestScore=0x0FFFFFFF;
	
	for (py=0;py<CURRENTY;py+=1) 
	{
		if ((m_pbPossibleNormal[nLine*CURRENTY+py])&&(py!=nBestLine_dessus))
		{
			if (m_pnMemoDistance[py*CURRENTY+nLine]==-1)
			{
				CalculDiffLine(nLine,py);	//calcul distance
			}
			else int yy=0;
				
			//find the min
			if ((m_pnMemoDistance[py*CURRENTY+nLine]!=-1)&&(m_pnMemoDistance[py*CURRENTY+nLine]<nBestScore))
			{
				nBestScore=m_pnMemoDistance[py*CURRENTY+nLine];
				nBestLine_dessous=py;
			} 
		}
		
	}

	_asm emms;				// output MMX mode

	if (nBestScore==0x0FFFFFFF)
		return false;

	*nBottomNearLineNear=nBestLine_dessous;
	*nTopNearLineNear=nBestLine_dessus;


	return(true);
}

inline void CLaVache::CalculDiffLine(int ligne1,int ligne2)
{
	//NiKral const __int64 maskdw  = 0x00000000FFFFFFFF;
	//NiKral const __int64 maskw12 = 0x0000FFFF0000FFFF;

	int * pnLine1,* pnLine2;
	int nSumDiff;
	int nLoopPx;

	if (m_pnMemoDistance[ligne1*CURRENTY+ligne2]!=-1)	//calcul yet calcul
		return;	

	nSumDiff=0;

	pnLine1=m_pnLineCurent288[ligne1];
	pnLine2=m_pnLineCurent288[ligne2];

	nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64);
	__int64 masklum = 0x00FF00FF00FF00FFLL;

	__asm                  // __asm Blockk
	{

		mov		edi,dword ptr[pnLine1]
		pxor    mm0,mm0		// mm0=0

		mov		esi,dword ptr[pnLine2]
		movq	mm7,masklum		//mm7=masklum
		
		mov		ecx,nLoopPx
		movq	mm6,mm7			//mm6=masklum

		jmp		AutrePixCDL

		align 16
	AutrePixCDL:

		movq	mm1,byte ptr[edi]		//mm1=*pnLine1
		movq	mm2,byte ptr[esi]		//mm2=*pnLine2

		pand	mm1,mm7					//mm1'=mm1&masklum
		pand	mm2,mm6					//mm2'=mm2&masklum

		movq	mm3,mm1					//mm3=mm1
		movq	mm4,mm2					//mm4=mm2

		psubusw	mm1,mm2					//mm1=mm1-mm2 -> =0 si ngatif
		add		edi,8			

		psubusw	mm4,mm3					//mm4=mm2-mm1 -> =0 si ngatif
		add		esi,8

		por		mm1,mm4					//mm1=mm1|mm4 -> mm1=|mm1'-mm2'|
		dec		ecx			
		
		paddw	mm0,mm1
		jnz		AutrePixCDL

		//additionne mm0
		movq		mm1,mm0				//mm1=mm0= A B C D (w)
		pxor		mm2,mm2				//mm2    = 0 0 0 0 (w)

		punpcklwd	mm0,mm2				//mm0=     0 C 0 D (w)
		punpckhwd	mm1,mm2				//mm1=     0 A 0 B (w)

		paddd		mm0,mm1				//mm0= (A+C)  (B+D) (dw)

		movq		mm1, mm0			//mm1= (A+C)  (B+D) (dw)
		punpckhdq	mm1, mm1			//mm1= (A+C)  (A+C) (dw)
		paddd		mm0, mm1			//mm0=   X    (A+B+C+D) (dw)

		movd		nSumDiff,mm0

	}

	m_pnMemoDistance[ligne1*CURRENTY+ligne2]=nSumDiff;
	m_pnMemoDistance[ligne2*CURRENTY+ligne1]=nSumDiff;


}

inline int CLaVache::CalculDiffColumn(int nIndexCulumn)
{ 
	__int64 masklum = 0x00FF00FF00FF00FFLL;
	int nSumDiffVabs = 0;

	int *pValue=&(m_pnColumnValue[nIndexCulumn][0]);
	short * psSort=&m_psSortLineCurrent[284];

	__asm
	{
		mov			esi, pValue
		movq		mm6, masklum	
		
		mov			edi, psSort
		pxor		mm7, mm7				// mm7 = nSumDiffVabs = 0

		mov			ecx, 284				// py=284	(multiple de 4)
		xor			eax,eax

		mov			ax,[edi+2]
		movd		mm3, [esi+eax*4]		// mm3 = 00000000 00000000 00000000 00000000  VVVVVVVV Y6Y6Y6Y6 UUUUUUUU Y5Y5Y5Y5

		jmp			Boucle1
		align		16
Boucle1:
		//read

		mov			ax,[edi]
		movd		mm0,byte ptr [esi+eax*4]	//mm0 = 00000000 00000000 00000000 00000000  VVVVVVVV Y2Y2Y2Y2 UUUUUUUU Y1Y1Y1Y1
		
		mov			ax,[edi-2]
		movd		mm1,byte ptr [esi+eax*4]	//mm1 = 00000000 00000000 00000000 00000000  VVVVVVVV Y4Y4Y4Y4 UUUUUUUU Y3Y3Y3Y3

		punpckldq	mm0, mm0				//mm0 = VVVVVVVV Y2Y2Y2Y2 UUUUUUUU Y1Y1Y1Y1  VVVVVVVV Y2Y2Y2Y2 UUUUUUUU Y1Y1Y1Y1
		punpckldq	mm1, mm3				//mm1 = VVVVVVVV Y6Y6Y6Y6 UUUUUUUU Y5Y5Y5Y5  VVVVVVVV Y4Y4Y4Y4 UUUUUUUU Y3Y3Y3Y3

		pand		mm0, mm6				//mm0 = 00000000 Y2Y2Y2Y2 00000000 Y1Y1Y1Y1  00000000 Y2Y2Y2Y2 00000000 Y1Y1Y1Y1
		movq		mm3, mm1				//mm3 = VVVVVVVV Y6Y6Y6Y6 UUUUUUUU Y5Y5Y5Y5  VVVVVVVV Y4Y4Y4Y4 UUUUUUUU Y3Y3Y3Y3

		movq		mm2, mm0				//mm2 = 00000000 Y2Y2Y2Y2 00000000 Y1Y1Y1Y1  00000000 Y2Y2Y2Y2 00000000 Y1Y1Y1Y1
		pand		mm1, mm6				//mm1 = 00000000 Y6Y6Y6Y6 00000000 Y5Y5Y5Y5  00000000 Y4Y4Y4Y4 00000000 Y3Y3Y3Y3	

		movq		mm4,mm1					//mm4 = 00000000 Y6Y6Y6Y6 00000000 Y5Y5Y5Y5  00000000 Y4Y4Y4Y4 00000000 Y3Y3Y3Y3	
		//|mm1'-mm2'|
		psubusw		mm0,mm1					//mm0 =  mm0-mm1 -> =0 si ngatif (w)

		psubusw		mm4,mm2					//mm4 = mm4-mm2 -> =0 si ngatif (w)
		sub			edi,4					//edi-=4

		por			mm0,mm4					//mm0 = mm0|mm4 -> mm1=|mm1'-mm2'| (w)
		//add the result into mm7

		sub			ecx,2					//py-=2
		paddw		mm7, mm0				//mm7 += mm0

		jnz			Boucle1

		//add mm7
		movq		mm1,mm7				//mm1=mm7= A B C D (w)
		pxor		mm2,mm2				//mm2    = 0 0 0 0 (w)

		punpcklwd	mm7,mm2				//mm7=     0 C 0 D (w)
		punpckhwd	mm1,mm2				//mm1=     0 A 0 B (w)

		paddd		mm7,mm1				//mm7= (A+C)  (B+D) (dw)

		movq		mm1, mm7			//mm1= (A+C)  (B+D) (dw)
		punpckhdq	mm1, mm1			//mm1= (A+C)  (A+C) (dw)
		paddd		mm7, mm1			//mm7=   X    (A+B+C+D) (dw)

		movd		nSumDiffVabs, mm7

	}


	return(nSumDiffVabs);
}


//main process
bool CLaVache::FindKeyWithDiff()
{	
	int i;

	m_nRateGoodProba=0;	

	if ((!m_bKeyFound)
		&&(m_pnLineCurent288[0])
		&&(m_pnLineOldSort288[m_bIsOdd][0]))
	{
		//init values
		m_nTestDone=0;
		ZeroMemory(m_pcKeyAlreadyFound,(128*256+1)*sizeof(*m_pcKeyAlreadyFound));

		if (m_nProbaNormalDynam<TresholdNormalDynamicInf)
			m_nProbaNormalDynam=TresholdNormalDynamicInf;

		//calcul  mask colums
		CalculColumnMask(NCOLUMNTESTED); 

		if ((!m_bOldKeyFound[m_bIsOdd])||(m_nTypeTryPrevious==1)||(!IsFrameFixe()))
		//if (1==1)		///debug
		{
			//FindKeyNormal
			FillMemory(m_pnMemoDistance,CURRENTY*CURRENTY*sizeof(int),0xFF); //-1 
			m_pnDiffColumnNormal[0]=-1;	

			CalculInterPixelLine();	

			for (i=0;i<m_nTestNormalUser;i++)
			{
				//find key with normal mode and line n m_psInterPixel[i]
				if (FindKeyNormal(m_psInterPixelNormal[i]))
					break;		//ok key found
			}

			//calcul Dynam coeff normal
			m_nProbaNormalDynam=(m_nProbaNormalDynam*2 + (abs(m_nProbaNormalLimitSup-m_nProbaNormalLimitInf)/2+m_nProbaNormalLimitInf)/COEFFILTERLIMIT )/3;

		}
		else
		{
			if (m_nProbaPreviousDynam<TresholdPreviousDynamicInf)
				m_nProbaPreviousDynam=TresholdPreviousDynamicInf;

			int nTestPreviousDone=0;
			int nTestNormalDone=0;

			while ((nTestPreviousDone<m_nTestPreviousUser)
				||(nTestNormalDone<m_nTestNormalUser))
			{
				
				if (nTestPreviousDone==0)
				{
					SetColumnOldSelect();
					CalculInterPixelLinePrevious();
					m_pnDiffColumnPrevious[0]=-1;	
				}

				if (nTestPreviousDone<m_nTestPreviousUser)
				{
					if (FindKeyPrevious(m_psInterPixelPrevious[nTestPreviousDone]))
						break;		//ok key found
					nTestPreviousDone++;
				}
				if (nTestPreviousDone<m_nTestPreviousUser)
				{
					if (FindKeyPrevious(m_psInterPixelPrevious[nTestPreviousDone]))
						break;		//ok key found
					nTestPreviousDone++;
				}

				if (nTestNormalDone==0)
				{
					FillMemory(m_pnMemoDistance,CURRENTY*CURRENTY*sizeof(int),0xFF); //-1 
					m_pnDiffColumnNormal[0]=-1;	
					CalculInterPixelLine();	
				}

				if (nTestNormalDone<m_nTestNormalUser)
				{
					if (FindKeyNormal(m_psInterPixelNormal[nTestNormalDone]))
						break;		//ok key found
					nTestNormalDone++;
				}
				if (nTestNormalDone<m_nTestNormalUser)
				{
					if (FindKeyNormal(m_psInterPixelNormal[nTestNormalDone]))
						break;		//ok key found
					nTestNormalDone++;
				}


			}

			//calcul Dynam coeff previous
			m_nProbaPreviousDynam=(m_nProbaPreviousDynam*2 + (abs(m_nProbaPreviousLimitSup-m_nProbaPreviousLimitInf)/2+m_nProbaPreviousLimitInf)/COEFFILTERLIMIT )/3;
			//calcul Dynam coeff normal
			m_nProbaNormalDynam=(m_nProbaNormalDynam*2 + (abs(m_nProbaNormalLimitSup-m_nProbaNormalLimitInf)/2+m_nProbaNormalLimitInf)/COEFFILTERLIMIT )/3;

		}


		//FindHeightBlack
		FindHeightBlackBorder();

		//if ((m_bKeyFound)&&(m_nTypeTryPrevious==2))
		//	ShowColumn();		//debug
	}
	
	return (m_bKeyFound);
} 


inline void CLaVache::CalculColumnMask(int nb_colonne)
{
	int i,py;
	int nColumnUsed;
	int nMaxScramb;
	int nMaxPosition;
	int nTemp;
	int nBound1,nBound2;
	bool bMaskColumn[MAXIMCOLUMNTESTED];   
	int nScrambColumn[MAXIMCOLUMNTESTED];	
	int nColumnPos[MAXIMCOLUMNTESTED];
	int nAverageColumn[MAXIMCOLUMNTESTED];

	ZeroMemory(nScrambColumn,sizeof(nScrambColumn));
	ZeroMemory(nAverageColumn,sizeof(nAverageColumn));

	int c =m_nSizeBufferX*1024/(2*(MAXIMCOLUMNTESTED+1));

	for (i=0;i<MAXIMCOLUMNTESTED;i++)
		nColumnPos[i]=(c*(i+1))/1024;  

	for (py=0;py<CURRENTY;py+=2)
	{
		for (i=0;i<MAXIMCOLUMNTESTED;i++)
		{
			nAverageColumn[i]+=(unsigned char)(*(m_pnLineCurent288[py]+nColumnPos[i]));
		}
	}
	for (i=0;i<MAXIMCOLUMNTESTED;i++)
	{
		nAverageColumn[i]=nAverageColumn[i]/(CURRENTY/2);
	}

	for (py=0;py<CURRENTY-1;py+=2)
	{
		for (i=0;i<MAXIMCOLUMNTESTED;i++)
		{
			nTemp=(unsigned char)(*(m_pnLineCurent288[py]+nColumnPos[i]))-nAverageColumn[i];
			if (nTemp<0)
				nTemp=0-nTemp;
			nScrambColumn[i]+=nTemp;
		}
	}


	nColumnUsed=0;
	
	ZeroMemory(bMaskColumn,sizeof(bMaskColumn));

	
	while(nColumnUsed<nb_colonne)
	{
		nMaxScramb=0;
		nMaxPosition=1;
		//search max
		nBound1=0;
		nBound2=MAXIMCOLUMNTESTED;
		
		//limit nBounds
		if (nColumnUsed==0)
			nBound2=MAXIMCOLUMNTESTED/2;
		if (nColumnUsed==1)
			nBound1=MAXIMCOLUMNTESTED/2;

		for (i=nBound1;i<nBound2;i+=1)
		{
			if (!bMaskColumn[i])
			{

				if (nScrambColumn[i]>=nMaxScramb)
				{
					nMaxScramb=nScrambColumn[i];
					nMaxPosition=i;
				}
			}
		}
		
		m_pnColumnSelect[nColumnUsed]=short(c*(nMaxPosition+1)/1024);
		bMaskColumn[nMaxPosition]=true;
		nColumnUsed++;
	}

	SetColumnSelect();
}


void CLaVache::SetColumnSelect() 
{
	//Set value in m_pnColumnValue
	int * pnLine;
	
	for (int py=0;py<CURRENTY;py++)
	{
		pnLine=m_pnLineCurent288[py];
		
		for (int nColum=0;nColum<NCOLUMNTESTED;nColum++)
		{
			m_pnColumnValue[nColum][py]=pnLine[m_pnColumnSelect[nColum]];

		}
	}

}


void CLaVache::SetColumnOldSelect() 
{
	//Set value in m_pnColumnOldSortValue
	int * pnLine;
	
	for (int py=0;py<CURRENTY;py++)
	{
		pnLine=m_pnLineOldSort288[m_bIsOdd][py];
		
		for (int nColum=0;nColum<NCOLUMNTESTED;nColum++)
		{
			m_pnColumnOldSortValue[m_bIsOdd][nColum][py]=pnLine[m_pnColumnSelect[nColum]];
		}
	}

}


inline void CLaVache::CalculInterPixelLine() 
{
	int i,j,py;
	int * pnLine;
	int nBestScore,position;
	int nSumDiff;

	int nLoopPx=m_nSizeBufferX/8-2;
	
	__int64 mask0000ffff = 0x0000ffff0000ffffLL;
	__int64 maskffff0000 = 0xffff0000ffff0000LL;
	__int64 mask00ff00ff = 0x00ff00ff00ff00ffLL;


	for (py=0;py<m_nTestNormalMaxi;py++)
	{
		pnLine=m_pnLineCurent288[m_pnPositionLineNormal[py]];

		__asm                  // __asm Blockk
		{
			pxor    mm0,mm0				// mm0=0

			mov		esi,dword ptr[pnLine]
			movq	mm7,mask00ff00ff	//mm7=masklum
			movq	mm5,mm7				//mm5=masklum

			mov		ecx,nLoopPx
			jmp AutrePixCIPL

			align 16
		AutrePixCIPL:

			//1
			movq	mm1,byte ptr[esi]		//mm1=*pnLine
			movq	mm2,byte ptr[esi+8]		//mm2=*pnLine +2 pixel

		
			pand	mm1,mm7					//mm1=mm1&masklum
			pand	mm2,mm5					//mm2=mm2&masklum

			movq	mm3,mm1					//mm3=mm1
			movq	mm4,mm2					//mm4=mm2

			psrld	mm3,16					//mm3=mm3>>16	(d)
			pslld	mm4,16					//mm4=mm4<<16	(d)

			pand	mm1,mask0000ffff		//mm1=mm1&mask0000ffff
			pand	mm2,maskffff0000		//mm2=mm2&maskffff0000

			por		mm1,mm2					//mm1|=mm2
			por		mm3,mm4					//mm3|=mm4

			paddw	mm1,mm3					//mm1+=mm2
			movq	mm6,mm1					//mm6=mm1

			//2
			movq	mm1,byte ptr[esi+4]		//mm1=*pnLine +1 pixel
			movq	mm2,byte ptr[esi+12]	//mm2=*pnLine +3 pixel

			pand	mm1,mm7					//mm1=mm1&masklum
			pand	mm2,mm5					//mm2=mm2&masklum

			movq	mm3,mm1					//mm3=mm1
			movq	mm4,mm2					//mm4=mm2

			psrld	mm3,16					//mm3=mm3>>16	(d)
			pslld	mm4,16					//mm4=mm4<<16	(d)

			pand	mm1,mask0000ffff		//mm1=mm1&mask0000ffff
			pand	mm2,maskffff0000		//mm2=mm2&maskffff0000

			por		mm1,mm2					//mm1|=mm2
			por		mm3,mm4					//mm3|=mm4

			paddw	mm1,mm3					//mm1+=mm2
			//
			psubw	mm1, mm6		 		//mm1=mm1-mm2 (w)

			add		esi,16
			pmaddwd	mm1, mm1				//mm1=mm1*mm1 (w) + (dw)
			
			dec ecx
			paddd	mm0, mm1				//mm0 += mm1 (dw)
		
			jnz AutrePixCIPL
			
			//add mm0
			movq		mm1, mm0
			punpckhdq	mm1, mm1
			paddd		mm0, mm1

			movd		nSumDiff,mm0
		}
		m_pnValueDiffPixelLine[py]=nSumDiff;
	}

	_asm emms;				// output MMX mode


	//calcul corrective factor
	int nCorrFactor;
	for (i=0;i<m_nTestNormalMaxi;i++)
	{
		nCorrFactor=((CURRENTY/2)-abs(m_pnPositionLineNormal[i]-(CURRENTY/2)))*2/(CURRENTY/2)+1;	//2+1=3
	}	m_pnValueDiffPixelLine[i]=m_pnValueDiffPixelLine[i]*nCorrFactor;

	//sort by max
	for (i=0;i<m_nTestNormalMaxi;i++)
	{
		nBestScore=-1;
		position=0;
		for (j=0;j<m_nTestNormalMaxi;j++)
		{
			if (m_pnValueDiffPixelLine[j]>nBestScore)
			{
				nBestScore=m_pnValueDiffPixelLine[j];
				position=j;	//score max
			}

		}
		m_psInterPixelNormal[i]=(short)position;	
		m_pnValueDiffPixelLine[position]=-1;

	}   
	

	//interlive
	for (i=0;i<(m_nTestNormalMaxi+1)/2;i++)
	{
		m_psInterliveSort[i*2]=m_psInterPixelNormal[i];
		m_psInterliveSort[i*2+1]=m_psInterPixelNormal[i+(m_nTestNormalMaxi+1)/2];
	}
	for (i=0;i<m_nTestNormalMaxi;i++)
		m_psInterPixelNormal[i]=m_psInterliveSort[i];

}


//save two trames for debug
bool CLaVache::SaveImage(short ** ppsBuffer1,short ** ppsBuffer2)
{
	FILE *sFile = fopen( File_Capture, "wb");
	char phrase[]="Capture MeuhMeuhTV | ";
	char indent[40];

	if(sFile == NULL)
		return false;

	//identifiant
	ZeroMemory(indent,sizeof(indent));
	CopyMemory(indent,phrase,sizeof(phrase));

	fwrite(indent, sizeof(indent),1,sFile);

	//dimension x
	fwrite(&m_nSizeBufferX, sizeof(m_nSizeBufferX),1,sFile);

	//dimension y
	int nSizeY=m_nSizeBufferY*2;
	fwrite(&nSizeY, sizeof(nSizeY),1,sFile);

	//donnes image
	for (int py=0;py<m_nSizeBufferY;py++)
	{
		fwrite((ppsBuffer1[py]),m_nSizeBufferX*2,1,sFile);
		fwrite((ppsBuffer2[py]),m_nSizeBufferX*2,1,sFile);
	}

	fclose(sFile);

	return true;
}

void CLaVache::SetLoadImageMode(bool bUsedLoadImage)
{
	m_bUsedLoadImage=bUsedLoadImage;
}


//load two trames for debug
bool CLaVache::LoadImage()
{
	int tcx,tcy;
	int i;
	char phrase[]="Capture MeuhMeuhTV | ";
	char indent[40];
	char indent2[40];


	FILE *sFile = fopen( File_Capture, "rb");

	if(sFile == NULL)
		return false;

	//identifiant
	ZeroMemory(indent,sizeof(indent));
	CopyMemory(indent,phrase,sizeof(phrase));

	fread(indent2, sizeof(indent2),1,sFile);
	for (i=0;i<40;i++)
	{
		if (indent[i]!=indent2[i])
		{
			fclose(sFile);
			return( false);	
		}
	}

	//dimension x
	fread(&tcx, sizeof(tcx),1,sFile);

	//dimension y
	fread(&tcy, sizeof(tcy),1,sFile);

	if ((tcx!=m_nSizeBufferX)|(tcy!=m_nSizeBufferY*2))
		return(false);

	//AllouRAM
	if (m_pnTamponChargeCapture)
		delete[] m_pnTamponChargeCapture;
	m_pnTamponChargeCapture=NULL;

	m_pnTamponChargeCapture=new int[tcx*tcy/2];
	if(!m_pnTamponChargeCapture)
		return false;

	//donnes image
	fread(m_pnTamponChargeCapture, tcx*tcy*2,1,sFile);

	fclose(sFile);

	return true;
}


void CLaVache::DirectBufferCopy(short ** ppsInputBuffer,short ** ppsOutputBuffer)
{
	// NiKral
	// for (int py=0;py<CURRENTY;py++)
	for (int py=0+m_nHeightBlackBorder;py<CURRENTY-m_nHeightBlackBorder;py++)
		ppsOutputBuffer[py]=ppsInputBuffer[py];

}


bool CLaVache::LoadFilePossiblePrevious()
{

	FILE *sFile = fopen(File_PossiblePrevious, "rb");

	if(sFile == NULL)
	{
		OutputDebugString("Impossible d'ouvrir le fichier accelerepos.fpc");
	   return false;
	}

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

	fread(m_pbPossiblePrevious, sizeof(*m_pbPossiblePrevious),CURRENTY*CURRENTY,sFile);

	fclose(sFile);


   return true;
}


bool CLaVache::LoadFileLinePrevious()
{
   int nZlr;
   FILE *sFile = fopen(File_LinePrevious, "rb");
   int nLineIndex;
   int nFullSize;
   short * adresse_clef;

   if(sFile == NULL)
      return false;

	if (!CheckFileID(sFile))
	{
		fclose(sFile);
		return false;
	}

   //line count
   fread(&m_nTestPreviousMaxi, sizeof(m_nTestPreviousMaxi),1,sFile);

   fread(&nFullSize, sizeof(nFullSize),1,sFile);

   m_psCountKeyLinePrevious=new short[nFullSize];
	if(m_psCountKeyLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return false;
	}

	m_pnPositionLinePrevious=new int[m_nTestPreviousMaxi];
	if(m_pnPositionLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return false;
	}


	m_ppsAdressKeyLinePrevious=new short* [m_nTestPreviousMaxi*CURRENTY*CURRENTY+1];
	if(m_ppsAdressKeyLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return false;
	}


	m_pcKeyLinePrevious=new unsigned char[m_nTestPreviousMaxi*CURRENTY*CURRENTY];
	if(m_pcKeyLinePrevious == NULL)
	{
      OutputDebugString("IDS_ERR_MEMORY");
      return false;
	}


	fread(m_psCountKeyLinePrevious, sizeof(*m_psCountKeyLinePrevious),nFullSize,sFile);

   
   adresse_clef=m_psCountKeyLinePrevious;
   for (nLineIndex=0;nLineIndex<m_nTestPreviousMaxi;nLineIndex++)
   {
	   //record line number
	   fread(m_pnPositionLinePrevious+nLineIndex, sizeof(*m_pnPositionLinePrevious),1,sFile);

	   //record key count ,line
	   fread(m_pcKeyLinePrevious+nLineIndex*CURRENTY*CURRENTY, sizeof(*m_pcKeyLinePrevious),CURRENTY*CURRENTY,sFile);

	   for(nZlr=0; nZlr<CURRENTY*CURRENTY; nZlr++)
	   {
		   //calcul pointers
			m_ppsAdressKeyLinePrevious[nLineIndex*CURRENTY*CURRENTY+nZlr]=adresse_clef;
			adresse_clef+=*(m_pcKeyLinePrevious+nLineIndex*CURRENTY*CURRENTY+nZlr);
	   }

   }

   fclose(sFile);
   return true;
}


bool CLaVache::FindKeyPrevious(int nLineIndex)
{

	int nKeyTested,nIndexKeyTested;
	int nBestScore;
	int nPropaGoodKey;
	int i;
	int ProbaOrdreLigneDecodeM0;
	int ProbaOrdreLigneDecodeM4;
	int nKeyKeep=0;
	int nCurrentColumnTest;

	int nOldBadKey=m_nKeyFound;

	if ((m_pnPositionLinePrevious[nLineIndex]<m_nHeightBlackBorder)
		||(m_pnPositionLinePrevious[nLineIndex]>CURRENTY-m_nHeightBlackBorder))
	{
		return(false);	//over line
	}
	if ((m_pnPositionLinePrevious[nLineIndex]+ECARTLIGNESUPERPOSITION<m_nHeightBlackBorder)
		||(m_pnPositionLinePrevious[nLineIndex]+ECARTLIGNESUPERPOSITION>CURRENTY-m_nHeightBlackBorder))
	{
		return(false);	//over line
	}

	//search lines near in the previous frame
	if (!FindLinePrevious(m_pnPositionLinePrevious[nLineIndex],-1,ProbaOrdreLigneDecodeM0))
		return(false);

	if (!FindLinePrevious(m_pnPositionLinePrevious[nLineIndex]+ECARTLIGNESUPERPOSITION,ProbaOrdreLigneDecodeM0,ProbaOrdreLigneDecodeM4))
		return(false);


	if (m_pcKeyLinePrevious[nLineIndex*CURRENTY*CURRENTY+ProbaOrdreLigneDecodeM0*CURRENTY+ProbaOrdreLigneDecodeM4]==0)
		return(false);


	if (m_pnDiffColumnPrevious[0]==-1)
	{	//m_pnDiffColumnNormal wasn't yet calculed

		for (int py=0;py<CURRENTY;py++)
			m_psSortLineCurrent[py]=py;

		//calcul nPropaGoodKey
		nPropaGoodKey=0;
		for (i=0;i<NCOLUMNTESTED;i++)	
		{	//1 passe
			nPropaGoodKey+=CalculDiffColumnPrevious(i,0x7fffffff);
			m_pnDiffColumnPrevious[i]=nPropaGoodKey;
		}
	}


	nCurrentColumnTest=m_nTestDone/2+3;
	if (nCurrentColumnTest>NCOLUMNTESTED)
		nCurrentColumnTest=NCOLUMNTESTED;


	//DifferenceColonnePrecedent
	nBestScore=0x0FFFFFFF;
	for (nIndexKeyTested=0;nIndexKeyTested<m_pcKeyLinePrevious[nLineIndex*CURRENTY*CURRENTY+ProbaOrdreLigneDecodeM0*CURRENTY+ProbaOrdreLigneDecodeM4];nIndexKeyTested++)
	{
		nKeyTested=*(m_ppsAdressKeyLinePrevious[nLineIndex*CURRENTY*CURRENTY+ProbaOrdreLigneDecodeM0*CURRENTY+ProbaOrdreLigneDecodeM4]+nIndexKeyTested);
		CreateLineOrder(nKeyTested,m_psSortLineCurrent);

		nPropaGoodKey=0;
		for (i=0;i<nCurrentColumnTest;i++)
		{	
			nPropaGoodKey+=CalculDiffColumnPrevious(i,nBestScore+10);	

			if (nPropaGoodKey>nBestScore)
				break;	//over -> out

		}

					
		if (nPropaGoodKey<nBestScore)
		{
			nBestScore=nPropaGoodKey;
			nKeyKeep=nKeyTested;
		}

		if (nIndexKeyTested>2)
		{
			m_nRateGoodProba=(m_pnDiffColumnPrevious[nCurrentColumnTest-1]-nBestScore)*100/(nBestScore+1);

			if (m_nRateGoodProba>170+m_nProbaPreviousDynam)	
				break;	//very good -> out
		}

	}

	_asm	emms;				// output MMX mode


	// Validation ?
	m_nTypeTryPrevious=1;

	if (nIndexKeyTested>0)
	{
		m_nRateGoodProba=(m_pnDiffColumnPrevious[nCurrentColumnTest-1]-nBestScore)*100/(nBestScore+1);
		if (m_nRateGoodProba<0)
			m_nRateGoodProba=0;

		m_nKeyFound=(short)nKeyKeep;

		if (m_nRateGoodProba>40+m_nProbaPreviousDynam-m_pcKeyAlreadyFound[nKeyKeep]*50)
		{
			CreateLineOrder(nKeyKeep,m_psSortLineCurrent);

			m_bKeyFound=true;
			m_nTestDone++;
		
			m_nTypeTryPrevious=2;	// => fixe frame					
			m_nLineIndexSelectPrevious=nLineIndex;
	
			//limit
			m_nProbaPreviousLimitSup=(m_nProbaPreviousLimitSup*COEFFILTERLIMIT+m_nRateGoodProba*COEFFILTERLIMIT)/(COEFFILTERLIMIT+1);
			if (m_nProbaPreviousLimitSup>TresholdPreviousLimitSup)
				m_nProbaPreviousLimitSup=TresholdPreviousLimitSup;

			return(true);
		}

	}


	//limit
	if ((m_nTestDone>0)&&(nOldBadKey!=m_nKeyFound)&&(m_pcKeyAlreadyFound[nKeyKeep]==0))
	{
		m_nProbaPreviousLimitInf=(m_nProbaPreviousLimitInf*COEFFILTERLIMIT+m_nRateGoodProba*COEFFILTERLIMIT)/(COEFFILTERLIMIT+1);
		if (m_nProbaPreviousLimitInf>TresholdPreviousLimitInf)
			m_nProbaPreviousLimitInf=TresholdPreviousLimitInf;
	}

	//incrise m_pcKeyAlreadyFound[nKeyKeep]
	m_pcKeyAlreadyFound[nKeyKeep]++;

	m_nTestDone++;
	return(false);

	//m_nTypeTryPrevious=2 -> fixe frame
	//m_nTypeTryPrevious=1 -> moving frame
	//m_nTypeTryPrevious=0 -> we don't know


}


inline bool CLaVache::FindLinePrevious(int nLine,int nLineNotUsed,int & nLineActualFound)
{	//search lines near in the previous frame

	int py;
	int nBestScore,nBestLine;
	int * pnLinePrevious,* pnLineActualTest;
	int nSumDiff;


	pnLinePrevious=m_pnLineOldSort288[m_bIsOdd][nLine];  

	nBestLine=0;
	nBestScore=0x0FFFFFFF;
	for (py=0;py<CURRENTY;py++)
	{
		if ((m_pbPossiblePrevious[nLine*CURRENTY+py])&&(py!=nLineNotUsed))
		{
			nSumDiff=0;
			pnLineActualTest=m_pnLineCurent288[py];

			CalculDiffLinePrevious(pnLineActualTest,pnLinePrevious,nSumDiff,nBestScore);

			if (nSumDiff<nBestScore)
			{
				nBestScore=nSumDiff;
				nBestLine=py;

			}
		}
	}

	_asm emms;				// output MMX mode

	nLineActualFound=nBestLine;
	
	if (nBestScore==0x0FFFFFFF)
		return( false);		//no line selected

	return(true);

}




inline void CLaVache::CalculDiffLinePrevious(int * pnLine1Current,int * pnLine2Near,int &nSumDiff,int nSumDiff_max)
{
	const int balayage_diff_pre=4;
	int saut=balayage_diff_pre*8;
	__int64 maskdw  = 0x00000000FFFFFFFFLL;
	__int64 maskw12 = 0x0000FFFF0000FFFFLL;
	__int64 masklum = 0x00FF00FF00FF00FFLL;

	int * pnLine1,* pnLine2;
	int nLoopPx;
	int phase;
	int nSumDiff_intermediaire=0;

	nSumDiff=0;

	nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64)/balayage_diff_pre;

	for (phase=0;phase<balayage_diff_pre;phase+=1)	//2 dword
	{
		pnLine1=pnLine1Current+phase*2;	// 2 dword
		pnLine2=pnLine2Near+phase*2;	// 2 dword

		__asm                  // __asm Blockk
		{

			mov		edi,dword ptr[pnLine1]	//courante
			pxor    mm0,mm0		// mm0=0
			
			mov		esi,dword ptr[pnLine2]	//avant
			movq	mm7,masklum			//mm7=masklum
			movq	mm6,mm7				//mm6=masklum

			mov		ecx,nLoopPx
			mov		eax,saut
			jmp		AutrePixCDLP

			align 16
		AutrePixCDLP:

			movq	mm1,byte ptr[edi]		//mm1=*pnLine1
			movq	mm2,byte ptr[esi]		//mm2=*pnLine2

			pand	mm1,mm6					//mm1'=mm1&masklum
			pand	mm2,mm7					//mm2'=mm2&masklum

			movq	mm3,mm1					//mm3=mm1
			movq	mm4,mm2					//mm4=mm2

			psubusw	mm1,mm2					//mm1=mm1-mm2 -> =0 si ngatif
			add		esi,eax					//2 dword

			psubusw	mm4,mm3					//mm4=mm2-mm1 -> =0 si ngatif
			add		edi,eax					//2 dword

			por		mm1,mm4					//mm1=mm1+mm4 -> mm1=|mm1'-mm2'|
			dec		ecx

			paddw	mm0,mm1
			jnz		AutrePixCDLP

			//additionne mm0
			movq		mm1,mm0				//mm1=mm0= A B C D (w)
			pxor		mm2,mm2				//mm2    = 0 0 0 0 (w)

			punpcklwd	mm0,mm2				//mm0=     0 C 0 D (w)
			punpckhwd	mm1,mm2				//mm1=     0 A 0 B (w)

			paddd		mm0,mm1				//mm0= (A+C)  (B+D) (dw)

			movq		mm1, mm0			//mm1= (A+C)  (B+D) (dw)
			punpckhdq	mm1, mm1			//mm1= (A+C)  (A+C) (dw)
			paddd		mm0, mm1			//mm0=   X    (A+B+C+D) (dw)
			
			movd 		nSumDiff_intermediaire,mm0

		}


		nSumDiff+=nSumDiff_intermediaire;

		if (nSumDiff>nSumDiff_max)
			break;	//over  -> out

	}

}



inline int CLaVache::CalculDiffColumnPrevious(int nIndexCulumn,int nMaxValue)
{ 

	__int64 masklum = 0x00FF00FF00FF00FFLL;
	int nSumDiffVabs = 0;
	int nThresholdMax=nMaxValue/2;	// divid by 2 because compare do in the half of nSumDiff (mm7)

	int *pValueColumnActual=&(m_pnColumnValue[nIndexCulumn][0]);
	short * psSortActual=&m_psSortLineCurrent[284];

	int *pValueColumnOldSort=&(m_pnColumnOldSortValue[m_bIsOdd][nIndexCulumn][284]);

	__asm
	{
		mov			esi, pValueColumnActual
		movq		mm6, masklum				//mm6=masklum	
		
		mov			edi, psSortActual
		xor			eax,eax						//exa=0
		
		mov			edx, pValueColumnOldSort			//edx= &(m_pnColumnOldSortValue[m_bIsOdd][284])
		pxor		mm7, mm7				// mm7 = nSumDiffVabs = 0
		
		mov			ecx, 284				//py=284	(multiple de 4)
		movq		mm5,mm6					//mm5=masklum

		jmp			Boucle1
		align		16
Boucle1:
		//----
		mov			ax,[edi]				
		movd		mm1,[edx]				//mm1 = 00000000 00000000 00000000 00000000  VVVVVVVV y2y2y2y2 UUUUUUUU y1y1y1y1						
		movd		mm0,byte ptr [esi+eax*4]//mm0 = 00000000 00000000 00000000 00000000  VVVVVVVV Y2Y2Y2Y2 UUUUUUUU Y1Y1Y1Y1
		
		mov			ax,[edi-2]
		punpckldq	mm1,[edx-4]				//mm1 = VVVVVVVV y4y4y4y4 UUUUUUUU y3y3y3y3  VVVVVVVV y2y2y2y2 UUUUUUUU y1y1y1y1
		punpckldq	mm0,byte ptr [esi+eax*4]//mm0 = VVVVVVVV Y4Y4Y4Y4 UUUUUUUU Y3Y3Y3Y3  VVVVVVVV Y2Y2Y2Y2 VVVVVVVV Y1Y1Y1Y1

		pand		mm1, mm5				//mm1 = 00000000 y4y4y4y4 00000000 y3y3y3y3  00000000 y2y2y2y2 00000000 y2y2y2y2	
		pand		mm0, mm6				//mm0 = 00000000 Y4Y4Y4Y4 00000000 Y3Y3Y3Y3  00000000 Y2Y2Y2Y2 00000000 Y1Y1Y1Y1
		psubw		mm0, mm1		 		//mm0 =            Y4-y4             Y3-y3              Y2-y2              Y1-y1 
		pmaddwd		mm0, mm0				//mm0 =     (Y4-y4)^2 + (Y3-y3)^2                (Y2-y2)^2 + (Y1-y1)^2
		paddd		mm7, mm0				//mm7 += mm0

		//----
		mov			ax,[edi+2]
		movd		mm1,[edx+4]				//mm1 = 00000000 00000000 00000000 00000000  VVVVVVVV y2y2y2y2 UUUUUUUU y1y1y1y1						
		movd		mm0,byte ptr [esi+eax*4]//mm0 = 00000000 00000000 00000000 00000000  VVVVVVVV Y2Y2Y2Y2 UUUUUUUU Y1Y1Y1Y1

		mov			ax,[edi+4]
		punpckldq	mm1,[edx+8]				//mm1 = VVVVVVVV y4y4y4y4 UUUUUUUU y3y3y3y3  VVVVVVVV y2y2y2y2 UUUUUUUU y1y1y1y1
		punpckldq	mm0,byte ptr [esi+eax*4]//mm0 = VVVVVVVV Y4Y4Y4Y4 UUUUUUUU Y3Y3Y3Y3  VVVVVVVV Y2Y2Y2Y2 VVVVVVVV Y1Y1Y1Y1

		pand		mm1, mm5				//mm1 = 00000000 y4y4y4y4 00000000 y3y3y3y3  00000000 y2y2y2y2 00000000 y2y2y2y2	
		pand		mm0, mm6				//mm0 = 00000000 Y4Y4Y4Y4 00000000 Y3Y3Y3Y3  00000000 Y2Y2Y2Y2 00000000 Y1Y1Y1Y1
		psubw		mm0, mm1		 		//mm0 =            Y4-y4             Y3-y3              Y2-y2              Y1-y1 
		
		sub			edx,16					//edx-=16
		pmaddwd		mm0, mm0				//mm0 =     (Y4-y4)^2 + (Y3-y3)^2                (Y2-y2)^2 + (Y1-y1)^2
		
		sub			edi,8					//edi-=8
		paddd		mm7, mm0				//mm7 += mm0

		//----
		movd		ebx,mm7
		sub			ebx,nThresholdMax
		jg			Boucle2					//dpacement Threshold -> fin boucle

		sub			ecx,4					//py-=4
		jnz			Boucle1

Boucle2:
		movq		mm0, mm7
		punpckhdq	mm0, mm0
		paddd		mm0, mm7
		movd		nSumDiffVabs, mm0

	}

	return(nSumDiffVabs);
}

inline void CLaVache::CalculInterPixelLinePrevious() 
{
	int i,j,py;
	int * pnLine;
	int nBestScore,position;
	int nSumDiff;

	
	int nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64)/2-2;
	__int64 mask0000ffff = 0x0000ffff0000ffffLL;
	__int64 maskffff0000 = 0xffff0000ffff0000LL;
	__int64 mask00ff00ff = 0x00ff00ff00ff00ffLL;


	for (py=0;py<m_nTestPreviousMaxi;py++)
	{
		pnLine=m_pnLineOldSort288[m_bIsOdd][m_pnPositionLinePrevious[py]];

		__asm                  // __asm Blockk
		{
			pxor    mm0,mm0				// mm0=0

			mov		esi,dword ptr[pnLine]
			movq	mm7,mask00ff00ff	//mm7=masklum
			movq	mm5,mm7				//mm5=masklum

			mov		ecx,nLoopPx
			jmp		AutrePixCIPLP

			align 16
		AutrePixCIPLP:

			//1
			movq	mm1,byte ptr[esi]		//mm1=*pnLine
			movq	mm2,byte ptr[esi+8]		//mm2=*pnLine +2 pixel

			pand	mm1,mm7					//mm1=mm1&masklum
			pand	mm2,mm5					//mm2=mm2&masklum

			movq	mm3,mm1					//mm3=mm1
			movq	mm4,mm2					//mm4=mm2

			psrld	mm3,16					//mm3=mm3>>16	(d)
			pslld	mm4,16					//mm4=mm4<<16	(d)

			pand	mm1,mask0000ffff		//mm1=mm1&mask0000ffff
			pand	mm2,maskffff0000		//mm2=mm2&maskffff0000

			por		mm1,mm2					//mm1|=mm2
			por		mm3,mm4					//mm3|=mm4

			paddw	mm1,mm3					//mm1+=mm2
			movq	mm6,mm1					//mm6=mm1

			//2
			movq	mm1,byte ptr[esi+4]		//mm1=*pnLine +1 pixel
			movq	mm2,byte ptr[esi+12]	//mm2=*pnLine +3 pixel

			pand	mm1,mm7					//mm1=mm1&masklum
			pand	mm2,mm5					//mm2=mm2&masklum

			movq	mm3,mm1					//mm3=mm1
			movq	mm4,mm2					//mm4=mm2

			psrld	mm3,16					//mm3=mm3>>16	(d)
			pslld	mm4,16					//mm4=mm4<<16	(d)

			pand	mm1,mask0000ffff		//mm1=mm1&mask0000ffff
			pand	mm2,maskffff0000		//mm2=mm2&maskffff0000

			por		mm1,mm2					//mm1|=mm2
			por		mm3,mm4					//mm3|=mm4

			paddw	mm1,mm3					//mm1+=mm2
			//
			psubw	mm1, mm6		 		//mm1=mm1-mm2 (w)

			add		esi,16
			pmaddwd	mm1, mm1				//mm1=mm1*mm1 (w) + (dw)
			
			dec ecx
			paddd	mm0, mm1				//mm0 += mm1 (dw)
		
			jnz AutrePixCIPLP
			//additionne mm0
			movq		mm1, mm0
			punpckhdq	mm1, mm1
			paddd		mm0, mm1

			movd		nSumDiff,mm0
		}
		m_pnValueDiffPixelLine[py]=nSumDiff;
	}

	_asm emms;				// output MMX mode


	//calcul corrective factor
	int nCorrFactor;
	for (i=0;i<m_nTestPreviousMaxi;i++)
	{
		nCorrFactor=((CURRENTY/2)-abs(m_pnPositionLinePrevious[i]-(CURRENTY/2)))*2/(CURRENTY/2)+1;	//2+1=3
	}	m_pnValueDiffPixelLine[i]=m_pnValueDiffPixelLine[i]*nCorrFactor;


	//sort max
	int position_a_remplacer=0;
	for (i=0;i<m_nTestPreviousMaxi;i++)
	{
		nBestScore=-1;
		position=0;
		for (j=0;j<m_nTestPreviousMaxi;j++)
		{
			if (m_pnValueDiffPixelLine[j]>nBestScore)
			{
				nBestScore=m_pnValueDiffPixelLine[j];
				position=j;	//score max
			}

		}
		m_psInterPixelPrevious[i]=(short)position;	
		m_pnValueDiffPixelLine[position]=-1;
		if (m_psInterPixelPrevious[i]==m_nLineIndexSelectPrevious)
			position_a_remplacer=i;
	}   



	//set p_Trame_Proche->m_nLineIndexSelectPrevious in fisrt
	int index_premier=m_nLineIndexSelectPrevious;
	if (index_premier!=-1)
	{
		m_psInterPixelPrevious[position_a_remplacer]=m_psInterPixelPrevious[0];
		m_psInterPixelPrevious[0]=index_premier;
	}


	//Interlive
	for (i=0;i<(m_nTestPreviousMaxi+1)/2;i++)
	{
		m_psInterliveSort[i*2]=m_psInterPixelPrevious[i];
		m_psInterliveSort[i*2+1]=m_psInterPixelPrevious[i+(m_nTestPreviousMaxi+1)/2];
	}
	for (i=0;i<m_nTestPreviousMaxi;i++)
		m_psInterPixelPrevious[i]=m_psInterliveSort[i];


}


//debug
void CLaVache::ShowColumn()		
{
	int py,nColumn;

	for (py=0;py<CURRENTY;py++)
	{
		for (nColumn=0;nColumn<NCOLUMNTESTED;nColumn++)
			*(m_pnLineCurent288[py]+m_pnColumnSelect[nColumn]+1)=0xFFFFFFFF;
	}

/*
	*(m_pnLineCurent288[m_pnPositionLinePrevious[m_nLineIndexSelectPrevious]]+0)=0xFFFFFFFF;
	*(m_pnLineCurent288[m_pnPositionLinePrevious[m_nLineIndexSelectPrevious]]+1)=0xFFFFFFFF;
	*(m_pnLineCurent288[m_pnPositionLinePrevious[m_nLineIndexSelectPrevious]]+2)=0xFFFFFFFF;
	*(m_pnLineCurent288[m_pnPositionLinePrevious[m_nLineIndexSelectPrevious]]+3)=0xFFFFFFFF;
	*(m_pnLineCurent288[m_pnPositionLinePrevious[m_nLineIndexSelectPrevious]]+4)=0xFFFFFFFF;
	*(m_pnLineCurent288[m_pnPositionLinePrevious[m_nLineIndexSelectPrevious]]+5)=0xFFFFFFFF;
*/
}

bool CLaVache::IsFrameFixe()
{
	int nColumnIndex1,nColumnIndex2;
	int nColumnID=0;

	for (nColumnIndex1=0;nColumnIndex1<NCOLUMNTESTED;nColumnIndex1++)
	{
		for (nColumnIndex2=0;nColumnIndex2<NCOLUMNTESTED;nColumnIndex2++)
		{
			if (m_pnColumnOldSelect[m_bIsOdd][nColumnIndex1]==m_pnColumnSelect[nColumnIndex2])
				nColumnID++;
		}
	}

	if (nColumnID>=5)
		return true;
	else 
		return false;
}


void CLaVache::RecordKeyRepeat(bool bKeyFound,int nKeyFound)
{
	if (bKeyFound)
	{
		if ((!m_bKeyRepeatLock)&&(m_psKeyRepeat[m_nPositionKeyRepeat]==nKeyFound))
			m_nGoodKeySynchrone++;
		else
			m_nGoodKeySynchrone=0;

		if (m_nGoodKeySynchrone==FREQREPEATKEY)
		{
			m_bKeyRepeatLock=true;	//lock !
			m_nPositionKeyRepeatFound=m_nPositionKeyRepeat+1;
			if (m_nPositionKeyRepeatFound>=FREQREPEATKEY)
				m_nPositionKeyRepeatFound=0;
			m_bKeyRepeatRead=true; //read key
			m_nBadKeySynchrone=0;
			m_nGoodKeySynchrone=0;
		}


		if ((m_bKeyRepeatLock)&&(m_bKeyRepeatRead)&&(m_psKeyRepeat[m_nPositionKeyRepeat]!=nKeyFound))
			m_nBadKeySynchrone++;

		m_psKeyRepeat[m_nPositionKeyRepeat]=nKeyFound;
	}
	else
	{
		m_psKeyRepeat[m_nPositionKeyRepeat]=-1;
	}


	m_nPositionKeyRepeat++;
	if (m_nPositionKeyRepeat>=FREQREPEATKEY)
		m_nPositionKeyRepeat=0;


	if (m_nBadKeySynchrone>3)
	{
		//m_nBadKeySynchrone=0;
		//m_bKeyRepeatLock=false;		//bad key -> UnLock !
		LossKeyRepeat();				//bad key -> UnLock !
	}

	if ((m_bKeyRepeatLock)&&(m_nPositionKeyRepeatFound==m_nPositionKeyRepeat))
	{
		if ((m_bKeyRepeatRead)&&(m_nBadKeySynchroneOld==m_nBadKeySynchrone)&&(m_nBadKeySynchrone>0))
			m_nBadKeySynchrone--;

		m_bKeyRepeatRead=!m_bKeyRepeatRead;		//toggle m_bKeyRepeatRead

		m_nBadKeySynchroneOld=m_nBadKeySynchrone;
	}
}


void CLaVache::LossKeyRepeat()
{
		m_nBadKeySynchrone=0;
		m_bKeyRepeatLock=false;		//unlock key repeat
}


bool CLaVache::UseKeyRepeat()
{
	int nDistance=abs(m_nPositionKeyRepeat-m_nPositionKeyRepeatFound);
	if (nDistance>FREQREPEATKEY/2)
		nDistance=FREQREPEATKEY-nDistance;

	if ((m_bKeyRepeatLock)
		&&(m_bKeyRepeatRead)
		&&(m_psKeyRepeat[m_nPositionKeyRepeat]!=-1)
		&&(nDistance>1))
	{
		m_nKeyFound=m_psKeyRepeat[m_nPositionKeyRepeat];
		CreateLineOrder(m_nKeyFound,m_psSortLineCurrent);
		m_nTypeTryPrevious=1;
		m_bKeyFound=true;
	}

	return m_bKeyFound;
}


void CLaVache::SetParams(int nTestNormalUser,int nTestPreviousUser,BOOL bFilterSECAM, \
						 BOOL bFilterPurple,BOOL bFilterAverage,BOOL bFilterSSE,int nPurpleLevel)
{
	// NiKral
	m_nTestNormalUser=nTestNormalUser;
	m_nTestPreviousUser=nTestPreviousUser;
	if ((nTestNormalUser<0)||(nTestNormalUser>m_nTestNormalMaxi))
		nTestNormalUser=0;
	if ((nTestPreviousUser<0)||(nTestPreviousUser>m_nTestPreviousMaxi))
		nTestPreviousUser=0;

	m_nLineIndexSelectPrevious=m_nTestPreviousMaxi/2;

	m_bFilterSECAM=(bFilterSECAM!=FALSE);
	m_bFilterPurple=(bFilterPurple!=FALSE);
	m_bFilterAverage=(bFilterAverage!=FALSE);
	m_bFilterSSE=(bFilterSSE!=FALSE);

	m_nPurpleLevel=nPurpleLevel;	// NiKral
}


inline bool CLaVache::DetectLineBlue(int * pnLine)
{
	const int ThresholdSaturation=m_nPurpleLevel;	// NiKral

	int ThresholdPixelMiss=(m_nSizeBufferX/2*20)/100;	// 20%
	int px;
	int nColorCurrent;
	int nSaturationMiss;


	nSaturationMiss=0;
	for (px=0;px<m_nSizeBufferX/2;px++)	
	{
		nColorCurrent=*(pnLine+px);
		if ((unsigned char)(nColorCurrent>>8)<ThresholdSaturation )
		{	// non bleu
			nSaturationMiss++;
	
			if (nSaturationMiss>ThresholdPixelMiss)	
				break;
		}

	}

	if (nSaturationMiss<=ThresholdPixelMiss)
		return true;

	return false;
}


inline bool CLaVache::DetectLineRed(int * pnLine)
{
	const int ThresholdSaturation=m_nPurpleLevel;	// NiKral

	int ThresholdPixelMiss=(m_nSizeBufferX/2*20)/100;	// 20%
	int px;
	int nColorCurrent;
	int nSaturationMiss;


	nSaturationMiss=0;
	for (px=0;px<m_nSizeBufferX/2;px++)	
	{
		nColorCurrent=*(pnLine+px);
		if ((unsigned char)(nColorCurrent>>24)<ThresholdSaturation )
		{	//non rouge 
			nSaturationMiss++;
	
			if (nSaturationMiss>ThresholdPixelMiss)
				break;
		}

	}

	if (nSaturationMiss<=ThresholdPixelMiss)
		return true;

	return false;
}

void CLaVache::FilterFrame(bool bPhaseFrame)
{

	if (m_bFilterPurple)
		FilterPurple();

	// NiKral
	if ((m_bFilterSECAM)&&(m_bFilterAverage))
	{
		FilterSecamWithAverage(bPhaseFrame);
	}
	else
	{
		if (m_bFilterSECAM)
			FilterSecam(bPhaseFrame);

		if (m_bFilterAverage)
			FilterAverage();
	}

}

void CLaVache::FilterAverage()
{
	int nLoopPx;
	int **ptr1, **ptr2; 

	int nBound1 = 0+m_nHeightBlackBorder;
	int nBound2 = CURRENTY-m_nHeightBlackBorder;

	__int64 masklum = 0x00FF00FF00FF00FFLL;
	__int64 maskcoul = 0xFF00FF00FF00FF00LL;

	if (!m_bOldKeyFound[m_bIsOdd])
		return;

	ptr1=(int**)m_pnLineSort288;
	ptr2=(int**)m_pnLineOldSort288[m_bIsOdd];

	if (!m_bFilterSSE) // NiKral
	{

		nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64);

		__asm		// MMX
		{
			movq	mm5,maskcoul
			mov		eax,nBound1
			movq	mm4,masklum
			movq	mm6,mm5

		AutreLigFA_MMX:
			mov		edx,ptr1	
			mov		edi,[edx+4*eax]			// adresse ligne image courante

			inc		eax

			mov		edx,ptr2
			mov		esi,[edx+eax*4-4]		// adresse ligne image prcdente
			mov		ecx,nLoopPx
				
			jmp		AutrePixFA_MMX
			align 16

		AutrePixFA_MMX:
			// lecture
			movq	mm0,byte ptr[esi]		//mm0=ligne_precedante
			movq	mm1,byte ptr[edi]		//mm1=ligne_courante				
			
			//moyenne couleur
			psrlw	mm0,1					//mm0=mm0 >>1 (w)
			movq	mm2,mm1					//mm2=ligne_courante

			psrlw	mm1,1					//mm1=mm1 >>1 (w)
			pand	mm2,mm4					//mm2=mm2&masklum

			pand	mm0,mm5					//mm0=mm0&maskcoul
			pand	mm1,mm6					//mm1=mm1&maskcoul

			add		edi,8	
			paddw	mm0,mm1
			
			add		esi,8
			por		mm0,mm2

			dec		ecx
			//stockage
			movq 	qword ptr[edi-8],mm0 
			jnz		AutrePixFA_MMX

			cmp		eax,nBound2
			jl		AutreLigFA_MMX
			
			emms							//ouput mmx mode
		}
	}
	else
	{

		nLoopPx=(m_nSizeBufferX*sizeof(short)/sizeof(__int64))/2;

		__asm		// SSE
		{
			movq	mm4,masklum
			mov		eax,nBound1
			movq	mm5,maskcoul

		AutreLigFA_SSE:
			mov		edx,ptr1	
			mov		edi,[edx+4*eax]			// adresse ligne image courante

			inc		eax

			mov		edx,ptr2
			mov		esi,[edx+eax*4-4]		// adresse ligne image prcdente
			mov		ecx,nLoopPx
				
			jmp		AutrePixFA_SSE
			align 16

		AutrePixFA_SSE:
			// lecture
			movq	mm0,byte ptr[esi]		//mm0=ligne image prcdente
			movq	mm1,byte ptr[edi]		//mm1=ligne image courante
			movq	mm2,byte ptr[esi+8]
			movq	mm3,byte ptr[edi+8]

			// moyenne couleur
			pavgb	mm0,mm1					//mm0=(mm0+mm1+1)/2		[SSE]
			pavgb	mm2,mm3					//mm2=(mm2+mm3+1)/2		[SSE]

			add		edi,16
			pand	mm1,mm4					//mm1=mm1&masklum
			pand	mm0,mm5					//mm0=mm0&maskcoul

			add		esi,16				
			pand	mm3,mm4					//mm3=mm3&masklum
			pand	mm2,mm5					//mm2=mm2&maskcoul
				
			por		mm0,mm1					//lum+coul
			por		mm2,mm3					//lum+coul
			dec		ecx

			// stockage
			movq 	qword ptr[edi-16],mm0
			movq 	qword ptr[edi-8],mm2

			jnz		AutrePixFA_SSE

			cmp		eax,nBound2
			jl		AutreLigFA_SSE

			emms							//ouput mmx mode
		}
	}
}

void CLaVache::FilterSecam(bool bPhaseFrame) 
{	//original idea : l'1Konnu

	int nBound1,nBound2;
	int nLoopPx;
	int **ptr1; 
	int tmp_bool;

	__int64 maskancienrouge =	0x00FFFFFF00FFFFFFLL;
	__int64 masknouveaurouge=	0xFF000000FF000000LL;
	__int64 maskancienbleu =	0xFFFF00FFFFFF00FFLL;
	__int64 masknouveaubleu=	0x0000FF000000FF00LL;

	if (m_nHeightBlackBorder>2)
	{
		nBound1=m_nHeightBlackBorder;
		nBound2=CURRENTY-m_nHeightBlackBorder;
	}
	else
	{
		nBound1=1;				// NiKral MMPlug 1.34
		nBound2=CURRENTY-1;
	}

	tmp_bool= (int)(!bPhaseFrame) ^ (nBound1&1!=0) ;

	ptr1=(int**)m_pnLineSort288;

	if (!m_bFilterSSE) // NiKral
	{

		nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64);

		__asm		// MMX
		{
		//modif Gondos
		//thanks Gondos !

			movq	mm4,maskancienrouge		//mask couleur a garder
			mov		eax,nBound1
			movq	mm5,masknouveaurouge	//mask couleur de remplacement
			mov		ebx,tmp_bool
			movq	mm6,maskancienbleu		//mask couleur a garder
			dec		eax
			movq	mm7,masknouveaubleu		//mask couleur de remplacement
			mov		edx,ptr1
			jmp		boucleMMX
			align 16

		boucleMMX:
			mov		esi,[edx+4*eax]			//pnLineNear reste dans esi
			movq	mm2,mm4					//mask couleur a garder rouge 
		
			inc		eax
			movq	mm3,mm5					//mask couleur de remplacement rouge

			xor		ebx,1					//if(tmp_bool^=1)
			mov		edi,[edx+eax*4]			//pnLineCurrent reste dans edi

			jne		fincasMMX	
		
			/////////////////////////////////////////
			//      Si il y a plus de bleu que     //
			//      que de  rouge a  corriger,     //
			//      mettre un 'je' et inverser     //
			//      mm6/mm4 et mm7/mm5 pour la     //
			//      branch prediction...           //
			/////////////////////////////////////////

			movq	mm2,mm6					//mask couleur a garder bleu
			movq	mm3,mm7					//mask couleur de remplacement bleu

		fincasMMX:
			mov		ecx,nLoopPx
			jmp		AutrePixelMMX
			align 16

		AutrePixelMMX:
			//read color
			movq	mm0,byte ptr[edi]		//mm0=pnLineCurrent
			movq	mm1,byte ptr[esi]		//mm1=pnLineNear

			//filter
			pand	mm0,mm2					//mm0=mm0&mm2 

			add		edi,8
			pand	mm1,mm3					//mm1=mm1&mm3

			add		esi,8
			por		mm0,mm1					//mm0=mm0|mm1

			dec		ecx 

			//record
			movq 	qword ptr[edi-8],mm0	//pnLineCurrent=mm0
			jnz		AutrePixelMMX			//Sortie

			cmp		eax,nBound2
			jl		boucleMMX

			emms							//ouput mmx mode
		}
	}
	else
	{

		nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64)/2;

		__asm		// SSE
		{
			movlps	xmm4,maskancienrouge		//mask couleur a garder
			movhps	xmm4,maskancienrouge		//mask couleur a garder
			mov		eax,nBound1
			movlps	xmm5,masknouveaurouge		//mask couleur de remplacement
			movhps	xmm5,masknouveaurouge		//mask couleur de remplacement
			mov		ebx,tmp_bool
			movlps	xmm6,maskancienbleu			//mask couleur a garder
			movhps	xmm6,maskancienbleu			//mask couleur a garder
			dec		eax
			movlps	xmm7,masknouveaubleu		//mask couleur de remplacement
			movhps	xmm7,masknouveaubleu		//mask couleur de remplacement
			mov		edx,ptr1	
			jmp		boucleSSE
			align 16

		boucleSSE:
			mov		esi,[edx+4*eax]				//adresse_ligne_proche reste dans esi
			movaps	xmm2,xmm4					//mask couleur a garder rouge 
		
			inc		eax
			movaps	xmm3,xmm5					//mask couleur de remplacement rouge

			xor		ebx,1	//if(tmp_bool^=1)
			mov		edi,[edx+eax*4]				//adresse_ligne_courante reste dans edi

			jne		fincasSSE

			movaps	xmm2,xmm6					//mask couleur a garder bleu
			movaps	xmm3,xmm7					//mask couleur de remplacement bleu

		fincasSSE:
			mov		ecx,nLoopPx
			jmp		AutrePixelSSE
			align 16

		AutrePixelSSE:
			//lecture couleur
			movlps	xmm0,qword ptr[edi]			//xmm0=*adresse_ligne_courante
			movhps	xmm0,qword ptr[edi+8]		//xmm0=*adresse_ligne_courante

			movlps	xmm1,qword ptr[esi]			//xmm1=*adresse_ligne_courante
			movhps	xmm1,qword ptr[esi+8]		//xmm1=*adresse_ligne_courante

			//filtrage
			andps	xmm0,xmm2					//xmm0=xmm0&xmm2

			add		edi,16
			andps	xmm1,xmm3					//xmm1=xmm1&xmm3

			add		esi,16
			orps	xmm0,xmm1					//xmm0=xmm0|xmm1

			dec		ecx

			//stockage
			movlps	[edi-16],xmm0				//stockage ligne courante
			movhps	[edi-8],xmm0

			jnz		AutrePixelSSE				//Sortie

			cmp		eax,nBound2
			jl		boucleSSE
		}
	}
}

void CLaVache::FilterPurple()
{

	int py;
	int * pnLineCurrent;
	int * pnLineNear;
	int nBound1,nBound2;
	int nLoopPx;
	bool bBlockSupPurple=false;
	bool bBlockInfPurple=false;

	//toggle array construction
	for (py=0;py<CURRENTY;py++)
	{
		m_psSortLineReverse[m_psSortLineCurrent[py]]=py;
	}

	if (m_nHeightBlackBorder>4)
	{
		nBound1=m_nHeightBlackBorder-4;
		nBound2=CURRENTY-m_nHeightBlackBorder+4; 
	}
	else
	{
		nBound1=0;
		nBound2=CURRENTY;
	}

	//Saturate lines calcul  --------------
	ZeroMemory(m_pbVioletDetect,sizeof(*m_pbVioletDetect)*CURRENTY);
	ZeroMemory(m_pbVioletSupprim,sizeof(*m_pbVioletSupprim)*CURRENTY);

	bool bImpaireOffset=((m_nKeyFound>>7)&0x01!=0);
	bBlockSupPurple=(((m_bIsOdd==0)^(bImpaireOffset))!=0);
	
	bBlockInfPurple=!bImpaireOffset;
	
	for (py=0;py<22;py++)	//not always purple
		m_pbVioletDetect[m_psSortLineReverse[py]]=DetectLinePurple(m_pnLineCurent288[py]);


	//Block Sup
	if (bBlockSupPurple)
	{
		for (py=32;py<53;py++)	//always purple
			m_pbVioletDetect[m_psSortLineReverse[py]]=true;
	}

	//Block Inf 
	if (bBlockInfPurple)
	{
		for (py=32;py<CURRENTY;py++)
		{
			if (m_psSortLineReverse[py]>254)
			{
				m_pbVioletDetect[m_psSortLineReverse[py]]=true;
				if (py+1<CURRENTY)
					m_pbVioletDetect[m_psSortLineReverse[py+1]]=true;
			}
		}
	}
	
	//Kill saturate lines
	__int64 masklum = 0x00FF00FF00FF00FFLL;
	__int64 maskcoul = 0xFF00FF00FF00FF00LL;
	__int64 maskcoul80 = maskcoul&0x8080808080808080LL;

	nLoopPx=(m_nSizeBufferX*sizeof(short)/sizeof(__int64))/2;

	if (!m_bFilterSSE) // NiKral
	{
		__asm		// MMX
		{
			movq	mm2,masklum
			movq	mm3,maskcoul
			movq	mm4,maskcoul80
		}
	}
	else
	{
		__asm		// SSE
		{
			movlps	xmm2,masklum
			movhps	xmm2,masklum
		
			movlps	xmm3,maskcoul
			movhps	xmm3,maskcoul
		
			movlps	xmm4,maskcoul80
			movhps	xmm4,maskcoul80
		}
		nLoopPx/=2;
	}

	//use near color border of lines
	for (py=nBound1;py<nBound2;py++)
	{
		if ((m_pbVioletDetect[py])&&(py>1)&&(py<CURRENTY-4))
		{
			if ((!m_pbVioletDetect[py-2])||(!m_pbVioletDetect[py+2]))
			{	
				m_pbVioletSupprim[py]=true;

				if ((!m_pbVioletDetect[py-2]))
					pnLineNear=m_pnLineSort288[py-2];
				else
					pnLineNear=m_pnLineSort288[py+2];
				
				pnLineCurrent=m_pnLineSort288[py];

				if (!m_bFilterSSE) // NiKral
				{
					__asm		// MMX
					{
						//modif Gondos + NiKral
						mov		esi,dword ptr[pnLineNear]
						mov		edi,dword ptr[pnLineCurrent]
						mov		ecx,nLoopPx
						jmp		AutrePixFP_MMX
						align 16

					AutrePixFP_MMX:
						movq	mm1,byte ptr[esi]			//mm1=ligne_precedente
						movq	mm7,byte ptr[esi+8]			//mm7=ligne_precedente

						movq	mm0,byte ptr[edi]			//mm0=ligne_courante
						movq	mm6,byte ptr[edi+8]			//mm6=ligne_courante

						//remplacement de la couleur
						pand	mm1,mm3						//mm1=mm1&maskcoul
						pand	mm7,mm3						//mm7=mm7&maskcoul

						add		edi,16
						pand	mm0,mm2						//mm0=mm0&masklum
						pand	mm6,mm2						//mm6=mm6&masklum

						add		esi,16
						por		mm0,mm1						//mm0=mm0|mm1 ajoute la couleur precedente
						por		mm6,mm7						//mm6=mm6|mm7 ajoute la couleur precedente

						dec ecx

						//stockage
						movq 	qword ptr[edi-16],mm0    
						movq 	qword ptr[edi-8],mm6

						jnz AutrePixFP_MMX
					}
				}
				else
				{
					__asm		// SSE
					{
						mov		esi,dword ptr[pnLineNear]
						mov		edi,dword ptr[pnLineCurrent]
						mov		ecx,nLoopPx
						jmp		AutrePixFP_SSE
						align 16

					AutrePixFP_SSE:
						movlps	xmm1,qword ptr[esi]			//xmm1=ligne_precedente
						movhps	xmm1,qword ptr[esi+8]		//xmm1=ligne_precedente

						movlps	xmm7,qword ptr[esi+16]		//xmm7=ligne_precedente
						movhps	xmm7,qword ptr[esi+24]		//xmm7=ligne_precedente

						movlps	xmm0,qword ptr[edi]			//xmm0=ligne_courante
						movhps	xmm0,qword ptr[edi+8]		//xmm0=ligne_courante

						movlps	xmm6,qword ptr[edi+16]		//xmm6=ligne_courante
						movhps	xmm6,qword ptr[edi+24]		//xmm6=ligne_courante

						andps	xmm1,xmm3					//xmm1=xmm1&maskcoul
						andps	xmm7,xmm3					//xmm7=xmm7&maskcoul

						add		edi,32
						andps	xmm0,xmm2					//xmm0=xmm0&masklum
						andps	xmm6,xmm2					//xmm6=xmm6&masklum

						add		esi,32
						orps	xmm0,xmm1					//xmm0=xmm0|xmm1
						orps	xmm6,xmm7					//xmm6=xmm6|xmm7

						dec ecx

						//record
						movlps	[edi-32],xmm0
						movhps	[edi-24],xmm0
						movlps	[edi-16],xmm6
						movhps	[edi-8],xmm6

						jnz AutrePixFP_SSE
					}
				}
			}

		}
	}

	//use previous frame or clear color
	for (py=nBound1;py<nBound2;py++)
	{
		if ((m_pbVioletDetect[py])&&(!m_pbVioletSupprim[py]))
		{
			pnLineCurrent=m_pnLineSort288[py];

			if ((m_bOldKeyFound[m_bIsOdd])&&(py<CURRENTY-1))
			{ 	//get color on previous frame
				pnLineNear=m_pnLineOldSort288[m_bIsOdd][py];

				if (!m_bFilterSSE) // NiKral
				{
					__asm		// MMX
					{
					//modif Gondos + NiKral
						mov		esi,dword ptr[pnLineNear]
						mov		edi,dword ptr[pnLineCurrent]
						mov		ecx,nLoopPx
						jmp		AutrePixFP2_MMX
						align 16

					AutrePixFP2_MMX:
						movq	mm1,byte ptr[esi]	//mm1=ligne_precedente (pixel_N)
						movq	mm7,byte ptr[esi+8]	//mm7=ligne_precedente (pixel_N+1)

						movq	mm0,byte ptr[edi]	//mm0=ligne_courante (pixel_N)
						movq	mm6,byte ptr[edi+8]	//mm6=ligne_courante (pixel_N+1)

						pand	mm1,mm3				//mm1=mm1&maskcoul
						pand	mm7,mm3				//mm7=mm7&maskcoul

						//fill color
						add		edi,16
						pand	mm0,mm2				//mm0=mm0&masklum
						pand	mm6,mm2				//mm6=mm6&masklum

						add		esi,16
						por		mm0,mm1				//mm0=mm0|mm1 ajoute la couleur precedente
						por		mm6,mm7				//mm6=mm6|mm7 ajoute la couleur precedente

						dec ecx
						//record
						movq 	qword ptr[edi-16],mm0    
						movq 	qword ptr[edi-8],mm6

						jnz AutrePixFP2_MMX
					}
				}
				else
				{
					__asm		// SSE
					{
						mov		esi,dword ptr[pnLineNear]
						mov		edi,dword ptr[pnLineCurrent]
						mov		ecx,nLoopPx
						jmp		AutrePixFP2_SSE
						align 16

					AutrePixFP2_SSE:
						movlps	xmm1,qword ptr[esi]		//xmm1=ligne_precedente
						movhps	xmm1,qword ptr[esi+8]	//xmm1=ligne_precedente

						movlps	xmm7,qword ptr[esi+16]	//xmm7=ligne_precedente
						movhps	xmm7,qword ptr[esi+24]	//xmm7=ligne_precedente

						movlps	xmm0,qword ptr[edi]		//xmm0=ligne_courante
						movhps	xmm0,qword ptr[edi+8]	//xmm0=ligne_courante

						movlps	xmm6,qword ptr[edi+16]	//xmm6=ligne_courante
						movhps	xmm6,qword ptr[edi+24]	//xmm6=ligne_courante

						andps	xmm1,xmm3				//xmm1=xmm1&maskcoul
						andps	xmm7,xmm3				//xmm7=xmm7&maskcoul

						add		edi,32
						andps	xmm0,xmm2				//xmm0=xmm0&masklum
						andps	xmm6,xmm2				//xmm6=xmm6&masklum

						add		esi,32
						orps	xmm0,xmm1				//xmm0=xmm0|xmm1
						orps	xmm6,xmm7				//xmm6=xmm6|xmm7

						dec ecx

						//record
						movlps	[edi-32],xmm0
						movhps	[edi-24],xmm0
						movlps	[edi-16],xmm6
						movhps	[edi-8],xmm6

						jnz AutrePixFP2_SSE
					}
				}
			}
			else
			{ // clear color

				if (!m_bFilterSSE) // NiKral
				{
					__asm		// MMX
					{
						//modif Gondos + NiKral
						mov		edi,dword ptr[pnLineCurrent]
						mov		ecx,nLoopPx
						jmp		AutrePixFP3_MMX
						align 16

					AutrePixFP3_MMX:
						movq	mm0,byte ptr[edi]		//mm0=ligne_courante
						movq	mm6,byte ptr[edi+8]		//mm6=ligne_courante

						// clear color
						pand	mm0,mm2					//mm0=mm0&masklum
						pand	mm6,mm2					//mm6=mm6&masklum
						add		edi,16

						por		mm0,mm4					//mm0=mm0|maskcoul80 -> noir et blanc
						por		mm6,mm4					//mm6=mm6|maskcoul80 -> noir et blanc
						dec		ecx

						//record
						movq 	qword ptr[edi-16],mm0
						movq 	qword ptr[edi-8],mm6

						jnz AutrePixFP3_MMX
					}
				}
				else
				{
					__asm		// SSE
					{
						mov		edi,dword ptr[pnLineCurrent]
						mov		ecx,nLoopPx
						jmp		AutrePixFP3_SSE
						align 16

					AutrePixFP3_SSE:
						movlps	xmm0,qword ptr[edi]		//xmm0=ligne_courante
						movhps	xmm0,qword ptr[edi+8]	//xmm0=ligne_courante

						movlps	xmm6,qword ptr[edi+16]	//xmm6=ligne_courante
						movhps	xmm6,qword ptr[edi+24]	//xmm6=ligne_courante

						// clear color
						andps	xmm0,xmm2				//xmm0=xmm0&masklum
						andps	xmm6,xmm2				//xmm6=xmm6&masklum
						add		edi,32

						orps	xmm0,xmm4				//xmm0=xmm0|maskcoul80 -> B&W
						orps	xmm6,xmm4				//xmm6=xmm6|maskcoul80 -> B&W
						dec		ecx

						//record
						movlps	[edi-32],xmm0
						movhps	[edi-24],xmm0
						
						movlps	[edi-16],xmm6
						movhps	[edi-8],xmm6

						jnz AutrePixFP3_SSE
					}
				}
			}
		}
	}
	if (!m_bFilterSSE)
		__asm    emms;		//ouput mmx mode	

}

//////////////////////////////////////////////////////////////////////////////////////
// NiKral - MeuhMeuhTV 1.93 by Fasouil (thanks ;-)

void CLaVache::FilterSecamWithAverage(bool bPhaseFrame)
{
	int nBound1,nBound2;
	int nLoopPx,tmp_bool;
	int **ptr1, **ptr2;

	__int64 maskancienrouge =	0x00FFFFFF00FFFFFFLL;
	__int64 masknouveaurouge=	0xFF000000FF000000LL;
	__int64 maskancienbleu =	0xFFFF00FFFFFF00FFLL;
	__int64 masknouveaubleu=	0x0000FF000000FF00LL;

	if (!m_bOldKeyFound[m_bIsOdd])
		return;

	if (m_nHeightBlackBorder>2)
	{
		nBound1=m_nHeightBlackBorder;
		nBound2=CURRENTY-m_nHeightBlackBorder;
	}
	else
	{
		nBound1=1;				// NiKral MMPlug 1.34
		nBound2=CURRENTY-1;
	}

	tmp_bool= (int)(!bPhaseFrame) ^ (nBound1&1!=0) ;
	
	ptr1=(int**)m_pnLineSort288;
	ptr2=(int**)m_pnLineOldSort288[m_bIsOdd];

	if (!m_bFilterSSE) // NiKral
	{

		nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64);
	
		__asm		// MMX
		{
			mov		eax,nBound1
			mov		ebx,tmp_bool
		
			dec		eax
			jmp		BoucleSA_MMX

			align 16

		BoucleSA_MMX:

			mov		edx,ptr1	
			mov		esi,[edx+4*eax]					//adresse_ligne_proche reste dans esi
			movq	mm2,maskancienrouge				//mask couleur a garder rouge 
		
			inc		eax
			movq	mm3,masknouveaurouge			//mask couleur de remplacement rouge

			xor		ebx,1							//if(tmp_bool^=1)
			mov		edi,[edx+eax*4]					//adresse_ligne_courante reste dans edi

			push	eax								//sauve eax

			mov		edx,ptr2
			mov		eax,[edx+eax*4-4]				//Image prcdente

			jne		Fincas_SA_MMX	
		
			movq	mm2,maskancienbleu				//mask couleur a garder bleu
			movq	mm3,masknouveaubleu				//mask couleur de remplacement bleu

		Fincas_SA_MMX:
			mov		ecx,nLoopPx
			jmp		AutrePixSA_MMX
			align 16
		AutrePixSA_MMX:
					
			// ** ANTI-BAVURE **

			//lecture couleur
			movq	mm0,byte ptr[edi]			//mm0=adresse_ligne_courante
			movq	mm1,byte ptr[esi]			//mm1=adresse_ligne_proche

			//filtrage
			add		edi,8
			pand	mm0,mm2						//mm0=mm0&mm2 LUM

			add		esi,8
			pand	mm1,mm3						//mm1=mm1&mm3 COUL

			// ** MOYENNEUR **
			movq	mm6,byte ptr[eax]			//mm6=Image d'avant
			psrlq	mm1,1						//mm1=mm1 >>1
			
			pand	mm6,mm3						//mm6=mm6&maskcoul Image d'avant
			psrlq	mm6,1						//mm6=mm6 >>1

			add		eax,8
			paddw	mm6,mm1						//mm6+=mm1 (w)
			

			pand	mm6,mm3						//mm6=mm6&maskcoul
			//assemble couleur et lum
			por		mm0,mm6						//mm0|=mm6

			dec		ecx 

			//stockage **
			movq 	qword ptr[edi-8],mm0		//adresse_ligne_courante=mm0

			jnz		AutrePixSA_MMX				//Sortie
			pop		eax							//restaure eax

			cmp		eax,nBound2
			jl		BoucleSA_MMX

			emms								//ouput mmx mode
		}
	}
	else
	{

		nLoopPx=m_nSizeBufferX*sizeof(short)/sizeof(__int64)/2;

		__asm		// SSE
		{
			mov		eax,nBound1
			mov		ebx,tmp_bool
		
			dec		eax
			jmp		BoucleSA_SSE

			align 16

		BoucleSA_SSE:

			mov		edx,ptr1	
			mov		esi,[edx+4*eax]				//adresse_ligne_proche reste dans esi
			movq	mm2,maskancienrouge			//mask couleur a garder rouge 
		
			inc		eax
			movq	mm3,masknouveaurouge		//mask couleur de remplacement rouge

			xor		ebx,1						//if(tmp_bool^=1)
			mov		edi,[edx+eax*4]				//adresse_ligne_courante reste dans edi

			push	eax							//sauve eax

			mov		edx,ptr2
			mov		eax,[edx+eax*4-4]			//Image prcdente

			jne		Fincas_SA_SSE	
		
			movq	mm2,maskancienbleu			//mask couleur a garder bleu
			movq	mm3,masknouveaubleu			//mask couleur de remplacement bleu

		Fincas_SA_SSE:
			mov		ecx,nLoopPx
			jmp		AutrePixSA_SSE
			align 16
		AutrePixSA_SSE:
					
			// ** ANTI-BAVURE **

			//lecture couleur
			movq	mm0,byte ptr[edi]			//mm0=adresse_ligne_courante
			movq	mm1,byte ptr[esi]			//mm1=adresse_ligne_proche

			movq	mm4,byte ptr[edi+8]			//mm4=adresse_ligne_courante
			movq	mm5,byte ptr[esi+8]			//mm5=adresse_ligne_proche

			movq   mm6,qword ptr[eax]   //mm6=Image d'avant V1.3.4.2 
			movq   mm7,qword ptr[eax+8]   //mm7=Image d'avant (+2 pixels) V1.3.4.2 

			//filtrage
			add		edi,16
			pand	mm0,mm2						//mm0=mm0&mm2 LUM
			pand	mm5,mm3						//mm5=mm5&mm3 COUL

			add		esi,16
			pand	mm1,mm3						//mm1=mm1&mm3 COUL
			pand	mm4,mm2						//mm4=mm4&mm2 LUM

			// ** MOYENNEUR **	V1.3.4.2 
			pavgb	mm6,mm1						//mm6=(mm6+mm1+1)/2		[SSE]
			pavgb	mm7,mm5						//mm6=(mm6+mm1+1)/2		[SSE]

			add		eax,16						// V1.3.4.2 
			pand	mm6,mm3						//mm6=mm6&maskcoul
			pand	mm7,mm3						//mm7=mm7&maskcoul

			//assemble couleur et lum
			por		mm0,mm6						//mm0|=mm6
			por		mm4,mm7						//mm4|=mm7

			dec		ecx

			//stockage **
			movq 	qword ptr[edi-16],mm0		//adresse_ligne_courante=mm0
			movq 	qword ptr[edi-8],mm4		//adresse_ligne_courante=mm4

			jnz		AutrePixSA_SSE				//Sortie
			pop		eax							//restaure eax

			cmp		eax,nBound2
			jl		BoucleSA_SSE

			emms								//ouput mmx mode
		}
	}
}

//////////////////////////////////////////////////////////////////////////////////////

inline bool CLaVache::DetectLinePurple(int * pnLine)
{
	const int ThresholdSaturation=m_nPurpleLevel;	// NiKral

	int ThresholdPixelMiss=(m_nSizeBufferX/2*20)/100;	// 20%
	int px;
	int nColorCurrent;
	int nSaturationMiss;

	nSaturationMiss=0;
	for (px=0;px<m_nSizeBufferX/2;px++)
	{
		nColorCurrent=*(pnLine+px);
		if (( (unsigned char)(nColorCurrent>>8)<ThresholdSaturation )
			&&( (unsigned char)(nColorCurrent>>24)<ThresholdSaturation ))
		{	///no red and no blue
			nSaturationMiss++;
	
			if (nSaturationMiss>ThresholdPixelMiss)	//miss nSaturationMiss
				break;
		}

	}

	if (nSaturationMiss<=ThresholdPixelMiss)
		return true;

	return false;
}


void CLaVache::FindHeightBlackBorder()
{
	if (!m_bKeyFound)
		return;

	const int nBackThresholdMax=60;
	const int nHeightThreshold=15;
	const int nHeightTested=70;
	const int nMaxBadLine=3;

	//top Threshold  
	int nBackAverage=0;
	for (int py=2;py<nHeightThreshold+2;py++)
	{
		for (int nColum=0;nColum<NCOLUMNTESTED;nColum++)
		{
			nBackAverage+=(unsigned char)(m_pnColumnValue[nColum][m_psSortLineCurrent[py]]);
		}
	}
	nBackAverage=nBackAverage/(NCOLUMNTESTED*nHeightThreshold)+6;
	if (nBackAverage>nBackThresholdMax)
		nBackAverage=nBackThresholdMax;

	//top border 0->nHeightTested
	int nBadBlackLine=0;
	for (int nBlackLineTop=2;nBlackLineTop<nHeightTested;nBlackLineTop++)
	{
		int nValueBlackLine=0;
		for (int nColum=0;nColum<NCOLUMNTESTED;nColum++)
		{
			nValueBlackLine+=(unsigned char)(m_pnColumnValue[nColum][m_psSortLineCurrent[nBlackLineTop]]);
		}
		nValueBlackLine=nValueBlackLine/NCOLUMNTESTED;
		if (nValueBlackLine>nBackAverage)
			nBadBlackLine++;
		if (nBadBlackLine>=nMaxBadLine)
			break;
	}
	nBlackLineTop-=nMaxBadLine;


	//bottom border CURRENTY-1->CURRENTY-HeightTested
	nBadBlackLine=0;
	for (int nBlackLineBottom=CURRENTY-3;nBlackLineBottom>=CURRENTY-nHeightTested;nBlackLineBottom--)
	{
		int nValueBlackLine=0;
		for (int nColum=0;nColum<NCOLUMNTESTED;nColum++)
		{
			nValueBlackLine+=(unsigned char)(m_pnColumnValue[nColum][m_psSortLineCurrent[nBlackLineBottom]]);
		}
		nValueBlackLine=nValueBlackLine/NCOLUMNTESTED;
		if (nValueBlackLine>nBackAverage)
			nBadBlackLine++;
		if (nBadBlackLine>=nMaxBadLine)
			break;
	}
	nBlackLineBottom+=nMaxBadLine;

	int nNewHeightBlack=min(nBlackLineTop,CURRENTY-nBlackLineBottom);
	if (nNewHeightBlack<10)
		nNewHeightBlack=0;
	
	m_fHeightBlackDynam=(float)((m_fHeightBlackDynam*10.0+nNewHeightBlack)/11.0);
}


int CLaVache::GetHeightBlackDynam()
{
	if (m_fHeightBlackDynam<20)
		return 0;
	else
		return((int)m_fHeightBlackDynam);
}


void CLaVache::SetHeightBlackBorder(int nHeightBlackBorder)
{
	m_nHeightBlackBorder=nHeightBlackBorder;
}


bool CLaVache::CheckFileID(FILE *sFile)
{
	if (!sFile)
		return false;

	char cCheckFileID[sizeof(cFileID)];
	char cCheckFileVersion[sizeof(cFileVersion)];


	if(fread(cCheckFileID,sizeof(cCheckFileID),1,sFile)==0)
		return false;

	if(fread(cCheckFileVersion,sizeof(cCheckFileVersion),1,sFile)==0)
		return false;

	//cCheckFileID
	for (int i=0;i<sizeof(cCheckFileID);i++)
	{
		if (cCheckFileID[i]!=cFileID[i])
			return false;
	}

	//cCheckFileVersion
	for (i=0;i<sizeof(cCheckFileVersion);i++)
	{
		if (cCheckFileVersion[i]!=cFileVersion[i])
			return false;
	}

	return true;
}
